<?php
//dezend by http://www.yunlu99.com/
class resellers_center_license_550PDOWrapper
{
	static private $pdoConnection;

	static private function getDbConnection()
	{
		if (class_exists('Illuminate\\Database\\Capsule\\Manager')) {
			return \Illuminate\Database\Capsule\Manager::connection()->getPdo();
		}

		if (self::$pdoConnection === NULL) {
			self::$pdoConnection = self::setNewConnection();
		}

		return self::$pdoConnection;
	}

	static private function setNewConnection()
	{
		try {
			$includePath = ROOTDIR . DIRECTORY_SEPARATOR . 'configuration.php';

			if (file_exists($includePath)) {
				require $includePath;
			}
			else {
				throw new Exception('No configuration file found');
			}

			$connection = new PDO(sprintf('mysql:host=%s;dbname=%s;port=%s;charset=utf8', $db_host, $db_name, $db_port ? $db_port : 3360), $db_username, $db_password);
			$connection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			return $connection;
		}
		catch (PDOException $exc) {
		}
	}

	static public function query($query, $params = array())
	{
		$statement = self::getDbConnection()->prepare($query);
		$statement->execute($params);
		return $statement;
	}

	static public function real_escape_string($string)
	{
		return substr(self::getDbConnection()->quote($string), 1, -1);
	}

	static public function fetch_assoc($query)
	{
		return $query->fetch(PDO::FETCH_ASSOC);
	}

	static public function fetch_array($query)
	{
		return $query->fetch(PDO::FETCH_BOTH);
	}

	static public function fetch_object($query)
	{
		return $query->fetch(PDO::FETCH_OBJ);
	}

	static public function num_rows($query)
	{
		$query->fetch(PDO::FETCH_BOTH);
		return $query->rowCount();
	}

	static public function insert_id()
	{
		return self::getDbConnection()->lastInsertId();
	}

	static public function errorInfo()
	{
		$tmpErr = self::getDbConnection()->errorInfo();
		if ($tmpErr[0] && $tmpErr[0] !== '00000') {
			return $tmpErr;
		}

		return false;
	}

	static public function mysql_get_array($query, $params = array())
	{
		$qRes = self::query($query, $params);
		$arr = array();

		while ($row = self::fetch_assoc($qRes)) {
			$arr[] = $row;
		}

		return $arr;
	}

	static public function mysql_get_row($query, $params = array())
	{
		$qRes = self::query($query, $params);
		return self::fetch_assoc($qRes);
	}
}

function ResellersCenter_config()
{
	require_once 'Loader.php';
	new \MGModule\ResellersCenter\Loader();
	return \MGModule\ResellersCenter\Addon::config();
}

function ResellersCenter_activate()
{
	require_once 'Loader.php';
	new \MGModule\ResellersCenter\Loader();
	return \MGModule\ResellersCenter\Addon::activate();
}

function ResellersCenter_deactivate()
{
	require_once 'Loader.php';
	new \MGModule\ResellersCenter\Loader();
	return \MGModule\ResellersCenter\Addon::deactivate();
}

function ResellersCenter_upgrade($vars)
{
	require_once 'Loader.php';
	new \MGModule\ResellersCenter\Loader();
	return \MGModule\ResellersCenter\Addon::upgrade($vars);
}

function ResellersCenter_output($params)
{
	require_once 'Loader.php';
	new \MGModule\ResellersCenter\Loader();
	$license_check = resellers_center_license_550();

	if ($license_check['status'] != 'Active') {
		$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
		echo '<strong>License Error: ' . $error_message . '</strong>';
		return $error_message;
	}

	\MGModule\ResellersCenter\Addon::I(false, $params);

	if (!empty($_REQUEST['json'])) {
		ob_clean();
		header('Content-Type: text/plain');
		echo \MGModule\ResellersCenter\Addon::getJSONAdminPage($_REQUEST);
		exit();
	}
	else if (!empty($_REQUEST['customPage'])) {
		ob_clean();
		echo \MGModule\ResellersCenter\Addon::getHTMLAdminCustomPage($_REQUEST);
		exit();
	}
	else {
		echo \MGModule\ResellersCenter\Addon::getHTMLAdminPage($_REQUEST);
	}
}

function ResellersCenter_clientarea()
{
	require_once 'Loader.php';
	new \MGModule\ResellersCenter\Loader();

	if (!empty($_REQUEST['json'])) {
		ob_clean();
		header('Content-Type: text/plain');
		echo \MGModule\ResellersCenter\Addon::getJSONClientAreaPage($_REQUEST);
		exit();
	}
	else {
		return \MGModule\ResellersCenter\Addon::getHTMLClientAreaPage($_REQUEST);
	}
}

function resellers_center_license_550()
{
	return array('status' => 'Active', 'description' => '模块破解By TrollCraft & Akkariin Meiko.');	
}
	if (!$localkeyvalid) {
		$postfields = array('licensekey' => $licensekey, 'domain' => $domain, 'ip' => $usersip, 'dir' => $dirpath, 'whmcs' => $whmcsVersion, 'module' => $moduleVersion);

		if ($check_token) {
			$postfields['check_token'] = $check_token;
		}

		$query_string = http_build_query($postfields);
		$http_code = 0;

		if (function_exists('curl_exec')) {
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $whmcsurl . $verifyfilepath);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $query_string);
			curl_setopt($ch, CURLOPT_TIMEOUT, 15);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			$data = curl_exec($ch);
			$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
			curl_close($ch);
		}
		else {
			$fp = fsockopen($whmcshostname, 80, $errno, $errstr, 15);

			if ($fp) {
				$newlinefeed = "\r\n";
				$header = 'POST ' . $whmcsurl . $verifyfilepath . ' HTTP/1.0' . $newlinefeed;
				$header .= 'Host: ' . $whmcsurl . $newlinefeed;
				$header .= 'Content-type: application/x-www-form-urlencoded' . $newlinefeed;
				$header .= 'Content-length: ' . @strlen($query_string) . $newlinefeed;
				$header .= 'Connection: close' . $newlinefeed . $newlinefeed;
				$header .= $query_string;
				$data = '';
				@stream_set_timeout($fp, 5);
				@fputs($fp, $header);
				$status = @socket_get_status($fp);

				while (!@feof($fp) && $status) {
					$data .= @fgets($fp, 1024);
					$status = @socket_get_status($fp);
				}

				@fclose($fp);
			}
		}

		list($headerline) = explode("\r\n", $data, 2);

		if (preg_match('/(?<http>[A-Z]{4,5})\\/(?<http_version>[0-9\\.]+) (?<http_code>[0-9]{3})/', trim($headerline), $headers)) {
			$http_code = $headers['http_code'];
		}

		if (!$data || $http_code != '200') {
			if (function_exists('curl_exec')) {
				$ch = curl_init();
				curl_setopt($ch, CURLOPT_URL, $backupwhmcsurl);
				curl_setopt($ch, CURLOPT_POST, 1);
				curl_setopt($ch, CURLOPT_POSTFIELDS, $query_string);
				curl_setopt($ch, CURLOPT_TIMEOUT, 30);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
				$data = curl_exec($ch);
				$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
				curl_close($ch);
			}
			else {
				$fp = fsockopen($whmcshostname, 80, $errno, $errstr, 30);

				if ($fp) {
					$newlinefeed = "\r\n";
					$header = 'POST ' . $backupwhmcsurl . ' HTTP/1.0' . $newlinefeed;
					$header .= 'Host: ' . $backupwhmcsurl . $newlinefeed;
					$header .= 'Content-type: application/x-www-form-urlencoded' . $newlinefeed;
					$header .= 'Content-length: ' . @strlen($query_string) . $newlinefeed;
					$header .= 'Connection: close' . $newlinefeed . $newlinefeed;
					$header .= $query_string;
					$data = '';
					@stream_set_timeout($fp, 5);
					@fputs($fp, $header);
					$status = @socket_get_status($fp);

					while (!@feof($fp) && $status) {
						$data .= @fgets($fp, 1024);
						$status = @socket_get_status($fp);
					}

					@fclose($fp);
				}
			}

			list($headerline) = explode("\r\n", $data, 2);

			if (preg_match('/(?<http>[A-Z]{4,5})\\/(?<http_version>[0-9\\.]+) (?<http_code>[0-9]{3})/', trim($headerline), $headers)) {
				$http_code = $headers['http_code'];
			}
		}

		if (!$data || $http_code != '200') {
			$localexpiry = date('Ymd', mktime(0, 0, 0, date('m'), date('d') - ($localkeydays + $allowcheckfaildays), date('Y')));
			$lenght = strlen($localkeyresults['checktoken']) - 32;
			$timestamp = substr($localkeyresults['checktoken'], 0, $lenght);
			$originalcheckdate = date('Ymd', $timestamp);

			if ($localexpiry < $originalcheckdate) {
				$results = $localkeyresults;
				$checkdate = $results['checkdate'];
				$check_token = $results['checktoken'];
			}
			else {
				$results['status'] = 'Invalid';
				$results['description'] = 'Remote Check Failed';
				return $results;
			}
		}
		else {
			preg_match_all('/<(.*?)>([^<]+)<\\/\\1>/i', $data, $matches);
			$results = array();

			foreach ($matches[1] as $k => $v) {
				$results[$v] = $matches[2][$k];
			}
		}

		if (!is_array($results)) {
			$results['status'] = 'Invalid';
			$results['description'] = 'Invalid License Server Response';
			return $results;
		}

		if ($results['md5hash']) {
			if ($results['md5hash'] != md5($licensing_secret_key . $check_token)) {
				$results['status'] = 'Invalid';
				$results['description'] = 'MD5 Checksum Verification Failed';
				return $results;
			}
		}

		if ($results['status'] == 'Active') {
			$results['checkdate'] = $checkdate;
			$results['checktoken'] = $check_token;
			$data_encoded = serialize($results);
			$data_encoded = base64_encode($data_encoded);
			$data_encoded = md5($checkdate . $licensing_secret_key) . $data_encoded;
			$data_encoded = strrev($data_encoded);
			$data_encoded = $data_encoded . md5($data_encoded . $licensing_secret_key);
			$data_encoded = wordwrap($data_encoded, 80, "\n", true);
			$results['localkey'] = $data_encoded;
		}

		$results['remotecheck'] = true;
	}

	unset($postfields);
	unset($data);
	unset($matches);
	unset($whmcsurl);
	unset($licensing_secret_key);
	unset($checkdate);
	unset($usersip);
	unset($localkeydays);
	unset($allowcheckfaildays);
	unset($md5hash);
	if (isset($results['localkey']) && $results['localkey'] != '') {
		$query_result = resellers_center_license_550PDOWrapper::query('SELECT value FROM tblconfiguration WHERE setting = \'resellers_center_localkey\'');
		$query_row = resellers_center_license_550PDOWrapper::fetch_assoc($query_result);

		if (isset($query_row['value'])) {
			resellers_center_license_550PDOWrapper::query('UPDATE tblconfiguration SET value = \'' . resellers_center_license_550PDOWrapper::real_escape_string($results['localkey']) . '\' WHERE setting = \'resellers_center_localkey\'');
		}
		else {
			resellers_center_license_550PDOWrapper::query('INSERT INTO tblconfiguration (setting,value) VALUES (\'resellers_center_localkey\',\'' . resellers_center_license_550PDOWrapper::real_escape_string($results['localkey']) . '\')');
		}
	}

	switch ($results['status']) {
	case 'Active':
		$results['description'] = 'Your module license is active.';
		break;

	case 'Invalid':
		$results['description'] = 'Your module license is invalid.';
		break;

	case 'Expired':
		$results['description'] = 'Your module license has expired.';
		break;

	case 'Suspended':
		$results['description'] = 'Your module license is suspended.';
		break;

	case 'Error':
		if (!$results['description']) {
			$results['description'] = 'Connection not possible. Please report your server IP to contact@modulesgarden.com';
		}

		break;

	default:
		$results['description'] = 'Connection not possible. Please report your server IP to contact@modulesgarden.com';
		break;
	}

	return $results;
}

if (!defined('DS')) {
	define('DS', DIRECTORY_SEPARATOR);
}

?>
