<?php
//dezend by http://www.yunlu99.com/
class account_synchronization_license_2676PDOWrapper
{
	static private $pdoConnection;

	static private function getDbConnection()
	{
		if (class_exists('Illuminate\\Database\\Capsule\\Manager')) {
			return \Illuminate\Database\Capsule\Manager::connection()->getPdo();
		}

		if (self::$pdoConnection === NULL) {
			self::$pdoConnection = self::setNewConnection();
		}

		return self::$pdoConnection;
	}

	static private function setNewConnection()
	{
		try {
			$includePath = ROOTDIR . DIRECTORY_SEPARATOR . 'configuration.php';

			if (file_exists($includePath)) {
				require $includePath;
			}
			else {
				throw new Exception('No configuration file found');
			}

			$connection = new PDO(sprintf('mysql:host=%s;dbname=%s;port=%s;charset=utf8', $db_host, $db_name, $db_port ? $db_port : 3360), $db_username, $db_password);
			$connection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			return $connection;
		}
		catch (PDOException $exc) {
		}
	}

	static public function query($query, $params = array())
	{
		$statement = self::getDbConnection()->prepare($query);
		$statement->execute($params);
		return $statement;
	}

	static public function real_escape_string($string)
	{
		return substr(self::getDbConnection()->quote($string), 1, -1);
	}

	static public function fetch_assoc($query)
	{
		return $query->fetch(PDO::FETCH_ASSOC);
	}

	static public function fetch_array($query)
	{
		return $query->fetch(PDO::FETCH_BOTH);
	}

	static public function fetch_object($query)
	{
		return $query->fetch(PDO::FETCH_OBJ);
	}

	static public function num_rows($query)
	{
		$query->fetch(PDO::FETCH_BOTH);
		return $query->rowCount();
	}

	static public function insert_id()
	{
		return self::getDbConnection()->lastInsertId();
	}

	static public function errorInfo()
	{
		$tmpErr = self::getDbConnection()->errorInfo();
		if ($tmpErr[0] && $tmpErr[0] !== '00000') {
			return $tmpErr;
		}

		return false;
	}

	static public function mysql_get_array($query, $params = array())
	{
		$qRes = self::query($query, $params);
		$arr = array();

		while ($row = self::fetch_assoc($qRes)) {
			$arr[] = $row;
		}

		return $arr;
	}

	static public function mysql_get_row($query, $params = array())
	{
		$qRes = self::query($query, $params);
		return self::fetch_assoc($qRes);
	}
}

function accountSynchronization_config()
{
	$dirname = dirname(__FILE__);
	$class = accountSynchronization_getclass();
	require_once $dirname . '/app/' . $class . '.php';
	$config = new $class();
	return array('name' => $config->name, 'description' => $config->description, 'author' => $config->author, 'version' => $config->version);
}

function accountSynchronization_activate($vars = array())
{
	$dirname = dirname(__FILE__);
	$basename = basename($dirname);
	defined('DS') || define('DS', DIRECTORY_SEPARATOR);
	require_once $dirname . '/app/core/PdoWrapper.php';
	require_once $dirname . '/helpers.php';
	require_once $dirname . '/app/core/ASLoader.php';
	$autoloader = new ASLoader();
	$autoloader->setIncludePath(dirname(dirname(__FILE__)) . DIRECTORY_SEPARATOR . array_get($_REQUEST, 'module', $basename));
	$autoloader->register();
	ASBootstrap::onActivate();
}

function accountSynchronization_deactivate()
{
	$dirname = dirname(__FILE__);
	$basename = basename($dirname);
	$class = accountSynchronization_getclass();
	defined('DS') || define('DS', DIRECTORY_SEPARATOR);
	require_once $dirname . '/app/core/PdoWrapper.php';
	require_once $dirname . '/helpers.php';
	require_once $dirname . '/app/core/ASLoader.php';
	$autoloader = new ASLoader();
	$autoloader->setIncludePath(dirname(dirname(__FILE__)) . DIRECTORY_SEPARATOR . array_get($_REQUEST, 'module', $basename));
	$autoloader->register();
	ASBootstrap::onDeactivate();
}

function accountSynchronization_upgrade($vars)
{
	$dirname = dirname(__FILE__);
	$basename = basename($dirname);
	$class = accountSynchronization_getclass();
	defined('DS') || define('DS', DIRECTORY_SEPARATOR);
	require_once $dirname . '/app/core/PdoWrapper.php';
	require_once $dirname . '/helpers.php';
	require_once $dirname . '/app/core/ASLoader.php';
	$autoloader = new ASLoader();
	$autoloader->setIncludePath(dirname(dirname(__FILE__)) . DIRECTORY_SEPARATOR . array_get($_REQUEST, 'module', $basename));
	$autoloader->register();
	ASBootstrap::onUpgrade($vars);
}

function accountSynchronization_output()
{
	global $lerror;
	$lerror = '';
	$dirname = dirname(__FILE__);
	defined('DS') || define('DS', DIRECTORY_SEPARATOR);
	require_once $dirname . '/app/core/PdoWrapper.php';
	require_once $dirname . '/helpers.php';
	require_once $dirname . '/app/core/ASLoader.php';
	$basename = basename($dirname);
	$autoloader = new ASLoader();
	$autoloader->setIncludePath(dirname(dirname(__FILE__)) . DIRECTORY_SEPARATOR . array_get($_REQUEST, 'module', $basename));
	$autoloader->register();
	$class = accountSynchronization_getclass();
	$license_check = account_synchronization_license_2676();

	if ($license_check['status'] != 'Active') {
		$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
		echo '<strong>License Error: ' . $error_message . '</strong>';
		return $error_message;
	}

	ASBootstrap::backend($class);
}

function accountSynchronization_clientarea($vars)
{
	$dirname = dirname(__FILE__);
	defined('DS') || define('DS', DIRECTORY_SEPARATOR);
	require_once $dirname . '/app/core/PdoWrapper.php';
	require_once $dirname . '/helpers.php';
	require_once $dirname . '/app/core/ASLoader.php';
	$dirname = dirname(__FILE__);
	$basename = basename($dirname);
	$autoloader = new ASLoader();
	$autoloader->setIncludePath(dirname(dirname(__FILE__)) . DIRECTORY_SEPARATOR . array_get($_REQUEST, 'module', $basename));
	$autoloader->register();
	$class = accountSynchronization_getclass();
	return ASBootstrap::frontend($class, $vars);
}

function accountSynchronization_getclass()
{
	$dirname = dirname(__FILE__);
	$basename = basename($dirname);
	return ucfirst($basename);
}

function accountSynchronization_getModuleClass($file)
{
	$dirname = dirname($file);
	$basename = basename($dirname);
	return $basename;
}

function account_synchronization_license_2676() {
	return array('status' => 'Active', 'description' => 'Crack By SakuraYAMI');
}

defined('WHMCS') || exit('This file cannot be accessed directly');
defined('DS') ? define('DS', DIRECTORY_SEPARATOR) : NULL;

?>
