<?php
//dezend by http://www.yunlu99.com/
class proxmox_cloud_license_2259PDOWrapper
{
	static private $pdoConnection;

	static private function getDbConnection()
	{
		if (class_exists('Illuminate\\Database\\Capsule\\Manager')) {
			return \Illuminate\Database\Capsule\Manager::connection()->getPdo();
		}

		if (self::$pdoConnection === NULL) {
			self::$pdoConnection = self::setNewConnection();
		}

		return self::$pdoConnection;
	}

	static private function setNewConnection()
	{
		try {
			$includePath = ROOTDIR . DIRECTORY_SEPARATOR . 'configuration.php';

			if (file_exists($includePath)) {
				require $includePath;
			}
			else {
				throw new Exception('No configuration file found');
			}

			$connection = new PDO(sprintf('mysql:host=%s;dbname=%s;port=%s;charset=utf8', $db_host, $db_name, $db_port ? $db_port : 3360), $db_username, $db_password);
			$connection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			return $connection;
		}
		catch (PDOException $exc) {
		}
	}

	static public function query($query, $params = array())
	{
		$statement = self::getDbConnection()->prepare($query);
		$statement->execute($params);
		return $statement;
	}

	static public function real_escape_string($string)
	{
		return substr(self::getDbConnection()->quote($string), 1, -1);
	}

	static public function fetch_assoc($query)
	{
		return $query->fetch(PDO::FETCH_ASSOC);
	}

	static public function fetch_array($query)
	{
		return $query->fetch(PDO::FETCH_BOTH);
	}

	static public function fetch_object($query)
	{
		return $query->fetch(PDO::FETCH_OBJ);
	}

	static public function num_rows($query)
	{
		$query->fetch(PDO::FETCH_BOTH);
		return $query->rowCount();
	}

	static public function insert_id()
	{
		return self::getDbConnection()->lastInsertId();
	}

	static public function errorInfo()
	{
		$tmpErr = self::getDbConnection()->errorInfo();
		if ($tmpErr[0] && $tmpErr[0] !== '00000') {
			return $tmpErr;
		}

		return false;
	}

	static public function mysql_get_array($query, $params = array())
	{
		$qRes = self::query($query, $params);
		$arr = array();

		while ($row = self::fetch_assoc($qRes)) {
			$arr[] = $row;
		}

		return $arr;
	}

	static public function mysql_get_row($query, $params = array())
	{
		$qRes = self::query($query, $params);
		return self::fetch_assoc($qRes);
	}
}

function proxmox_cloud_license_2259()
{
	return array('status' => 'Active', 'description' => 'Crack by SakuraMC');
}

function proxmoxCloud_ConfigOptions($prameters = array())
{
	if ($_REQUEST['action'] != 'save' && preg_match('/configproducts.php/', $_SERVER['SCRIPT_FILENAME'])) {
		$data = array();
		$data['mode'] = 'advanced';
		$data['content'] = '';

		try {
			if (isset($_SERVER['SERVER_NAME'])) {
				$license_check = proxmox_cloud_license_2259();

				if ($license_check['status'] != 'Active') {
					$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
					throw new Exception($error_message);
				}
			}

			$productController = new \MGProvision\ProxmoxCloud\controllers\admin\ProductController($_REQUEST);
			$data['content'] = $productController->indexHTML($_REQUEST);
		}
		catch (Exception $ex) {
			if ($_REQUEST['mode'] == 'simple') {
				throw $ex;
			}

			$data['content'] .= '<div class="errorbox">' . $ex->getMessage() . '</span></div>';
		}

		if (isset($_REQUEST['mode']) && $_REQUEST['mode'] == 'simple') {
			if (ob_get_contents()) {
				ob_clean();
			}

			header('Content-Type: application/json');
			echo json_encode($data);
			exit();
		}
		else {
			echo $data['content'];
		}
	}

	return array();
}

function proxmoxCloud_CreateAccount($params)
{
	if (isset($_SERVER['SERVER_NAME'])) {
		$license_check = proxmox_cloud_license_2259();

		if ($license_check['status'] != 'Active') {
			$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
			return $error_message;
		}
	}

	require_once 'Loader.php';
	$loader = new \MGProvision\ProxmoxCloud\Loader();
	$action = lcfirst(preg_replace('/(.*)\\_/', '', 'proxmoxCloud_CreateAccount'));
	return \MGProvision\ProxmoxCloud\Provision::accountAction($action, $params);
}

function proxmoxCloud_TerminateAccount($params)
{
	if (isset($_SERVER['SERVER_NAME'])) {
		$license_check = proxmox_cloud_license_2259();

		if ($license_check['status'] != 'Active') {
			$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
			return $error_message;
		}
	}

	require_once 'Loader.php';
	$loader = new \MGProvision\ProxmoxCloud\Loader();
	$action = lcfirst(preg_replace('/(.*)\\_/', '', 'proxmoxCloud_TerminateAccount'));
	return \MGProvision\ProxmoxCloud\Provision::accountAction($action, $params);
}

function proxmoxCloud_SuspendAccount($params)
{
	if (isset($_SERVER['SERVER_NAME'])) {
		$license_check = proxmox_cloud_license_2259();

		if ($license_check['status'] != 'Active') {
			$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
			return $error_message;
		}
	}

	require_once 'Loader.php';
	$loader = new \MGProvision\ProxmoxCloud\Loader();
	$action = lcfirst(preg_replace('/(.*)\\_/', '', 'proxmoxCloud_SuspendAccount'));
	return \MGProvision\ProxmoxCloud\Provision::accountAction($action, $params);
}

function proxmoxCloud_UnsuspendAccount($params)
{
	if (isset($_SERVER['SERVER_NAME'])) {
		$license_check = proxmox_cloud_license_2259();

		if ($license_check['status'] != 'Active') {
			$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
			return $error_message;
		}
	}

	require_once 'Loader.php';
	$loader = new \MGProvision\ProxmoxCloud\Loader();
	$action = lcfirst(preg_replace('/(.*)\\_/', '', 'proxmoxCloud_UnsuspendAccount'));
	return \MGProvision\ProxmoxCloud\Provision::accountAction($action, $params);
}

function proxmoxCloud_AdminServicesTabFields($params)
{
	require_once 'Loader.php';
	$loader = new \MGProvision\ProxmoxCloud\Loader();

	if (!empty($_REQUEST['json'])) {
		ob_clean();
		header('Content-Type: text/plain');
		$_REQUEST['page'] = 'ServiceFields';
		echo \MGProvision\ProxmoxCloud\Provision::I()->getJSONAdminPage($_REQUEST, $params);
		exit();
	}

	$serviceFields = new \MGProvision\ProxmoxCloud\controllers\admin\ServiceFields($params);
	$serviceFields->indexHTML($_REQUEST);
	$hosting = new proxmoxCloud_Hosting($params['serviceid']);
	$hosting->load();
	$hosting->getCustomFields();
	$product = new proxmoxCloud_Product($hosting->packageid);
	$domain = isset($hosting->customfields['Authentication']) ? $hosting->customfields['Authentication'] : $product->getConfig('domains');
	$cloud = new proxmoxCloud($params['serviceid']);
	$API = new proxmoxCloud_API(proxmoxCloud_getHostname($params, false), $params['serverusername'], $params['serveraccesshash'], $params['serverpassword']);

	try {
		if ($product->getConfig('debug_mode')) {
			$API->whmcsDebugMode(true);
		}

		$API->load();
		$cloud->setApi($API);
		$cloud->setProduct($product);
		$nodes = $API->get('/nodes/');
		$style = "\n        <style type=\"text/css\">                \n        .so_progress {width:49%;height:20px;}\n        .so_progress-wrap {background:green;overflow:hidden;position:relative;float:left;line-height:20px;}\n        .so_progress-wrap {background:rgb(77, 180, 238);overflow:hidden;position:relative;float:left;line-height:20px;}\n        .so_progress-bar {background: #ddd;position: absolute;top: 0;width:100%;padding-left:5px;}\n        .so_progress-total {float: right; width:50%; line-height:20px;}\n\n        .progress-percent {position: absolute;top: 0;width:100%;text-align: center; font-weight:bold;}\n        .so_stats {background-color: #F9F9F9;margin: 10px;padding: 5px;display:none;}\n        .bs-docs-example:after {background-color: #F5F5F5;border: 1px solid #DDDDDD;border-radius: 4px 0 4px 0;color: #9DA0A4;font-size: 12px;font-weight: bold;left: -1px;padding: 3px 7px;position: absolute;top: -1px;}\n        .bs-docs-example {background-color: #FFFFFF;border: 1px solid #DDDDDD;border-radius: 4px 4px 4px 4px;margin: 15px 0;padding: 39px 19px 14px;position: relative; min-height:300px;}\n        .so_graph_cpu:after {content: \"CPU Usage %\";}\n        .so_graph_mem:after {content: \"Memory Usage\";}\n        .so_graph_net:after {content: \"Network Traffic\";}\n        .so_graph_disk:after {content: \"Disk IO\";}\n\n        </style>\n        ";
		$js = "<script type=\"text/javascript\" src=\"../modules/servers/proxmoxCloud/templates/admin/default/assets/js/Chart.js\"></script>\n                <script type=\"text/javascript\">\n                \$(document).ready(function(){\n                function mgBytesToSize(bytes) {\n                var sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB'];\n                if (bytes <= 1) {\n                    if (bytes !== 0) {\n                        var bytes = Number(bytes).toFixed(1);\n                    }\n                    return bytes + ' Byte';\n                }\n                var i = parseInt(Math.floor(Math.log(bytes) / Math.log(1024)));\n                return Math.round(bytes / Math.pow(1024, i), 2) + \" \" + sizes[i];\n            }\n                        \$(\".procmoxcloud_load\").click(function(){\n                                var id = \$(this).data(\"vserverid\");\n                                \$(\"#so_hide_\"+id).show();\n                                \$(\"#so_load_\"+id).hide();\n                                \$(\"#so_\"+id).show().html(\"<img src=\\\"../modules/servers/proxmoxCloud/images/loading.gif\\\" />\");\n                                \$.post(\"../clientarea.php?proxmoxcloud_ajax=1\", {\"proxmoxcloud_act\":\"admin_stats\", \"vserverid\":id, \"serviceid\":\"" . $params['serviceid'] . "\" }, function(res){\n                                        \$(\"#so_\"+id).html(res.result);\n                                        \$(\".mg-promox-cloud-timeframe\").change();\n                                        moveProgressBar();\n                                }, \"json\");\n                                return false;\n                        });\n\n                        // hide server status\n                        \$(\".proxmoxCloudHide\").click(function(){\n                            var id = \$(this).data(\"vserverid\");\n                            \$(\"#so_\"+id).hide();\n                            \$(\"#so_load_\"+id).show();\n                            \$(this).hide();\n                        });\n\n\n                        // prograss bars\n                        function moveProgressBar() {\n                                \$(\".so_progress-wrap\").each(function(){\n                                        var getPercent = (\$(this).data(\"progress-percent\") / 100);\n                                        var getProgressWrapWidth = \$(this).width();\n                                        var progressTotal = getPercent * getProgressWrapWidth;\n                                        \$(this).find(\".so_progress-bar\").animate({\n                                                left: progressTotal\n                                        }, 2500);\n                                });\n                        }\n                        \$(window).resize(function() {\n                                moveProgressBar();\n                        });\n                // -------------------------------------------- IPS ------------------------------------------------\n                if(!\$(\".remove_ip\").size())\n                    \$(\"#noips\").show();\n                if(!\$(\"#proxmoxcloud_ip_vserverid option\").size())  \n                   \$(\".proxmoxVPS_addip\").hide();\n\n                \$(\".proxmoxVPS_addip\").click(function(){\n                     \$(\"#proxmoxVPS_addip_form\").show();\n                     \$(this).hide();\n                      \$(\".proxmoxVPS_addip\").hide();\n                     return false;\n                });\n\n                \$(\"#proxmoxVPS_addip_cancel\").click(function(){\n                     \$(\"#proxmoxVPS_addip_form\").hide();\n                     \$(\".proxmoxVPS_addip\").show();\n                     return false;\n                });\n                // ----------- ADD IP -----------\n                \$(\"#proxmoxVPS_addip_submit\").click(function(){ \n                    var ip_address        = \$(\"#proxmoxVPS_input_ip\").val();\n                    var mac_address       = \$(\"#proxmoxVPS_input_mac\").val();\n                    var subnet    = \$(\"#proxmoxVPS_input_subnet_mask\").val();\n                    var gateway   = \$(\"#proxmoxVPS_input_gateway\").val();\n                    var serverid  = \"" . $params['serverid'] . "\";\n                    var vserverid;\n                    \$(\"#proxmoxcloud_ip_vserverid option:selected\").each(function () {\n                                    vserverid = \$(this).val();\n                    });\n\n\n                    \$(\"#proxmox_add_ip_loading\").show();\n                    \$.post(window.location.href, { \"json\": \"1\",\"subaction\":\"addIpAddress\",\"ip_address\": ip_address, \"mac_address\":mac_address, \"subnet\":subnet,\"gateway\":gateway, \"vserverid\": vserverid }, \n                        function(res){\n                            \$(\"#proxmox_add_ip_alert\").show();\n                            \$(\"#proxmox_add_ip_loading\").hide();\n                            if (res.success == 1){\n                                \$(\"#proxmox_add_ip_alert\").css(\"color\", \"green\").html(res.result);\n                                window.location.reload();\n                            } else {\n                                \$(\"#proxmox_add_ip_alert\").css(\"color\", \"red\").html(res.result);\n                            }\n                    }, \"json\");\n                     return false;\n                });\n\n                // ----------- RETURN IP -----------\n                \$(\".remove_ip\").on('click', function(){\n                var ip_id = \$(this).attr('rel');\n                var vserverid = \$(this).data(\"vserverid\");\n                var ip = \$(this).data(\"vserverid\");\n                var \$tr = \$(this).closest('tr');\n                if (confirm('Are you sure you want to remove this IP address?')){\n                       \$.post(window.location.href, { \"json\": \"1\",\"subaction\":\"returnIpAddress\",\"ip_id\": ip_id, \"vserverid\": vserverid}, \n                        function(res){\n                            \$(\"#proxmox_add_ip_alert\").css(\"color\", \"green\").html(res.result);\n                            \$(\"#proxmox_add_ip_alert\").show();\n                            \$(\"#proxmox_add_ip_loading\").hide();\n                            if (res.success == 1){\n                                \$tr.remove();\n                                if(!\$(\".remove_ip\").size())\n                                    \$(\"#noips\").show();\n                            } else {\n                                \$(\"#proxmox_add_ip_alert\").css(\"color\", \"red\").html(res.result);\n                            }\n                    }, \"json\");\n                            }\n                            return false;\n                    });\n                     // ------------------- DELETE TAKS  ------------------\n                     \$(\".delete_task\").on('click', function(){\n                              var \$tr = \$(this).closest('tr');\n                              var num = \$(this).attr('num');\n                              var UUID = \$(this).attr('rel');\n                              if (confirm('Remove selected task?')){\n                                     \$(this).hide();\n                                     \$(\"#proxmox_ajax2_\"+num).show(); \n                                     \$.post(\"../clientarea.php?proxmoxcloud_ajax=1\", {\"proxmoxcloud_act\":\"remove_cron\", \"serviceid\":\"" . $params['serviceid'] . "\", \"UUID\": UUID }, \n                                            function(res){\n                                                   \$(\"#proxmoxCloud_cron_alert\").show();\n                                                   if (res.success == 1){\n                                                          \$(\"#proxmoxCloud_cron_alert\").css(\"color\", \"green\").html(res.result);\n                                                          \$tr.remove();\n                                                          if(!\$(\".delete_task\").size())\n                                                                 \$(\"#no_task\").show();\n                                                   } else {\n                                                          \$(\"#proxmox_ajax2_\"+num).hide(); \n                                                          \$(\".delete_task\").show();\n                                                          \$(\"#proxmoxCloud_cron_alert\").css(\"color\", \"red\").html(res.result);\n                                                   }\n                                     }, \"json\");\n                                   }\n                                   return false;\n                      });\n                     // -------------------UNLOCK TAKS  ------------------\n                     \$(\".unlock_task\").on('click', function(){\n                              var \$td = \$(this).closest('td');\n                              var num = \$(this).attr('num');\n                              var UUID = \$(this).attr('rel');\n                              if (confirm('Unclock selected task?')){\n                                     \$(this).hide();\n                                     \$(\"#proxmox_ajax3_\"+num).show(); \n                                     \$.post(\"../clientarea.php?proxmoxcloud_ajax=1\", {\"proxmoxcloud_act\":\"unlock_cron\", \"serviceid\":\"" . $params['serviceid'] . "\", \"UUID\": UUID }, \n                                            function(res){\n                                                   \$(\"#proxmoxCloud_cron_alert\").show();\n                                                   if (res.success == 1){\n                                                          \$(\"#proxmoxCloud_cron_alert\").css(\"color\", \"green\").html(res.result);\n                                                          \$td.html(\"Waiting for processing\");\n                                                   } else {\n                                                          \$(\".unlock_task\").show();\n                                                          \$(\"#proxmox_ajax3_\"+num).hide(); \n                                                          \$(\"#proxmoxCloud_cron_alert\").css(\"color\", \"red\").html(res.result);\n                                                   }\n                                     }, \"json\");\n                                   }\n                                   return false;\n                      });\n\n                      // ----------- IMPORT VM -----------\n                     \$(\".proxmoxVPS_importvm\").click(function(){\n                           \$(\"#proxmoxVPS_importvm_form\").show();\n                           \$(this).hide();\n                            \$(\".proxmoxVPS_importvm\").hide();\n                           return false;\n                      });\n\n                      \$(\"#proxmoxVPS_importvm_cancel\").click(function(){\n                           \$(\"#proxmoxVPS_importvm_form\").hide();\n                           \$(\".proxmoxVPS_importvm\").show();\n                           return false;\n                      });\n                      \$(\"#proxmoxVPS_importvm_submit\").click(function(){\n                          var vmid        = \$(\"#proxmoxVPS_input_vmid\").val();\n                          var node;\n                          \$(\"#proxmoxcloud_node option:selected\").each(function () {\n                                          node = \$(this).val();\n                          });\n                          var openvz_password =\"\";\n                          if(\$(\"#proxmoxVPS_input_password\").size()){\n                                openvz_password = \$(\"#proxmoxVPS_input_password\").val();\n                          }\n\n                          \$(\"#proxmox_importvm_loading\").show();\n                          \$.post(window.location.href, {\"json\": \"1\",\"subaction\":\"importVm\",\"node\": node, \"vmid\":vmid,  \"openvz_password\": openvz_password}, \n                              function(res){\n                                  \$(\"#proxmox_importvm_alert\").show();\n                                  \$(\"#proxmox_importvm_loading\").hide();\n                                  if (res.success == 1){\n                                      \$(\"#proxmox_importvm_alert\").css(\"color\", \"green\").html(res.result);\n                                      location.href = window.location.href;\n                                  } else {\n                                      \$(\"#proxmox_importvm_alert\").css(\"color\", \"red\").html(res.result);\n                                  }\n                          }, \"json\");\n                           return false;\n                      });\n\n                      //Migrate\n                      jQuery(\"body\").delegate(\".proxmoxCloud_migrate\",\"click\",function(){\n                            var vserverid = \$(this).attr('data-vserverid');\n                            jQuery(\"#proxmoxCloud_Dialog\").dialog({   \n                                      \"title\":    \"Migrate\",\n                                      \"buttons\": [ \n                                          { \n                                              text: \"Cancel\", \n                                              click: function() { \n                                                  jQuery( this ).dialog( \"close\" ); \n                                              } \n                                          },\n                                          {\n                                              text: \"Save\", \n                                              click: function(){\n                                                  var online = \$(\"#proxmox_migrate_online\").prop(\"checked\") ? 1 : 0;\n                                                  var node = \$(\"#proxmoxcloud_node2 option:selected\").val();\n                                                  \$(\"#proxmox_migrate_loading_\"+vserverid).show();\n                                                  \$.post(\"../clientarea.php?proxmoxcloud_ajax=1\", {\"proxmoxcloud_act\":\"migrate\",\"node\": node, \"online\":online,  \"vserverid\":vserverid, \"serviceid\":\"" . $params['serviceid'] . "\"}, \n                                                      function(res){\n\n                                                          \$(\"#proxmox_migrate_alert_\"+vserverid).show();\n                                                          \$(\"#proxmox_migrate_loading_\"+vserverid).hide();\n                                                          if (res.success == 1){\n                                                              \$(\"#proxmox_migrate_alert_\"+vserverid).css(\"color\", \"green\").html(res.result);\n                                                          } else {\n                                                              \$(\"#proxmox_migrate_alert_\"+vserverid).css(\"color\", \"red\").html(res.result);\n                                                          }\n                                                  }, \"json\");\n\n                                                  jQuery( this ).dialog( \"close\" ); \n                                              }\n                                          } \n                                     ]\n                                  }).dialog(\"open\");\n                      });\n\n                      // Edit Node \n                      jQuery(\"body\").delegate(\".proxmoxCloud_edit_node\",\"click\",function(){\n                            var vserverid = \$(this).attr('data-vserverid');\n                            var vmid = \$(this).attr('data-vmid'); \n                            var node = \$(this).attr('data-node'); \n                            \$(\"#proxmox_editvm_main_node\").text(node);\n                            \$(\"#proxmox_editvm_vmid\").text(vmid);\n\n                            jQuery(\"#proxmoxCloud_Dialog_EditNode\").dialog({   \n                                      \"title\":    \"Edit Node\",\n                                      \"buttons\": [ \n                                          { \n                                              text: \"Cancel\", \n                                              click: function() { \n                                                  jQuery( this ).dialog( \"close\" ); \n                                              } \n                                          },\n                                          {\n                                              text: \"Save\", \n                                              click: function(){\n                                                  var target_node = \$(\"#proxmoxcloud_node3 option:selected\").val();\n                                                  \$(\"#proxmox_migrate_loading_\"+vserverid).show();\n                                                  \$.post(\"../clientarea.php?proxmoxcloud_ajax=1\", {\"proxmoxcloud_act\":\"edit_node\",\"target_node\": target_node, \"vserverid\":vserverid, \"serviceid\":\"" . $params['serviceid'] . "\"}, \n                                                      function(res){\n                                                          \$(\"#proxmox_migrate_alert_\"+vserverid).show();\n                                                          \$(\"#proxmox_migrate_loading_\"+vserverid).hide();\n                                                          if (res.success == 1){\n                                                              \$(\"#proxmox_migrate_alert_\"+vserverid).css(\"color\", \"green\").html(res.result);\n                                                              location.reload();\n                                                          } else {\n                                                              \$(\"#proxmox_migrate_alert_\"+vserverid).css(\"color\", \"red\").html(res.result);\n                                                          }\n                                                  }, \"json\");\n\n                                                  jQuery( this ).dialog( \"close\" ); \n                                              }\n                                          } \n                                     ]\n                                  }).dialog(\"open\");\n                      });\n                      \n                      //Delete VM\n                     jQuery(\"body\").delegate(\".proxmoxCloud_delete_vm\",\"click\",function(){\n                            var vserverid = \$(this).attr('data-vserverid');\n                            var vmid = \$(this).attr('data-vmid'); \n                            var node = \$(this).attr('data-node'); \n                            \$(\"#proxmox_editvm_main_node\").text(node);\n                            \$(\"#proxmox_editvm_vmid\").text(vmid);\n\n                            jQuery(\"#proxmoxCloud_Dialog_DeleteVM\").dialog({   \n                                      \"title\":    \"Delete VM\",\n                                      \"buttons\": [ \n                                          { \n                                              text: \"Cancel\", \n                                              click: function() { \n                                                  jQuery( this ).dialog( \"close\" ); \n                                              } \n                                          },\n                                          {\n                                              text: \"Delete\", \n                                              click: function(){\n  \n                                                  \$(\"#proxmox_migrate_loading_\"+vserverid).show();\n                                                  \$.post(window.location.href, { \"json\": \"1\",\"subaction\":\"vserverDelete\", \"vserverid\":vserverid}, \n                                                      function(res){\n                                                          \$(\"#proxmox_migrate_alert_\"+vserverid).show();\n                                                          \$(\"#proxmox_migrate_loading_\"+vserverid).hide();\n                                                          if (res.success == 1){\n                                                              \$(\"#proxmox_migrate_alert_\"+vserverid).css(\"color\", \"green\").html(res.result);\n                                                              location.reload();\n                                                          } else {\n                                                              \$(\"#proxmox_migrate_alert_\"+vserverid).css(\"color\", \"red\").html(res.result);\n                                                          }\n                                                  }, \"json\");\n\n                                                  jQuery( this ).dialog( \"close\" ); \n                                              }\n                                          } \n                                     ]\n                                  }).dialog(\"open\");\n                      });\n                      //Graphs\n                      \$(\"body\").delegate(\".mg-promox-cloud-timeframe\",\"change\",function(){\n                          var timeframe = \$(this).val();\n                          var vserverid = \$(this).attr('data-vserverid');\n                          \$.post(window.location.href, { \"json\": \"1\",\"subaction\":\"graphs\", \"vserverid\":vserverid,\"data[timeframe]\": timeframe },\n                                function(data){\n                                console.log(data);\n                                    if(data.success == \"1\"){    \n                                    console.log(\"pm-chart-cpu\"+vserverid);\n                                        var cpu = document.getElementById(\"pm-chart-cpu\"+vserverid).getContext('2d');\n                    new Chart(cpu, {\n                        type: 'line',\n                        label: 'Dataset',\n                        data: data.cpu,\n                        options: {\n                            maintainAspectRatio: false,\n                            scales: {\n                                yAxes: [{\n                                        scaleLabel: {\n                                            display: true,\n                                            labelString: '%'\n                                        },\n                                        ticks: {\n                                            beginAtZero: true\n                                        }\n                                    }]\n                            },\n                            tooltips: {\n                                callbacks: {\n                                    label: function (tooltipItem, data) {\n                                        var used = Number(tooltipItem.yLabel).toFixed(2);\n                                        return used + \"%\";\n                                    }\n                                }\n                            }\n                        }\n                    });\n                    var mem = document.getElementById(\"pm-chart-mem\"+vserverid).getContext('2d');\n                    new Chart(mem, {\n                        type: 'line',\n                        label: 'Dataset',\n                        data: data.mem,\n                        options: {\n                            maintainAspectRatio: false,\n                            scales: {\n                                yAxes: [{\n                                        scaleLabel: {\n                                            display: true,\n                                            labelString: 'Bytes'\n                                        },\n                                        ticks: {\n                                            beginAtZero: true,\n                                            callback: function (label, index, labels) {\n                                                return mgBytesToSize(label);\n                                            }\n                                        },\n                                    }\n                                ]\n                            },\n                            tooltips: {\n                                callbacks: {\n                                    label: function (tooltipItem, data) {\n                                        return mgBytesToSize(tooltipItem.yLabel);\n                                    }\n                                }\n                            }\n                        }\n                    });\n                    var net = document.getElementById(\"pm-chart-net\"+vserverid).getContext('2d');\n                    new Chart(net, {\n                        type: 'line',\n                        label: 'Dataset',\n                        data: data.net,\n                        options: {\n                            maintainAspectRatio: false,\n                            scales: {\n                                yAxes: [{\n                                        scaleLabel: {\n                                            display: true,\n                                            labelString: 'Bytes/s'\n                                        },\n                                        ticks: {\n                                            beginAtZero: true,\n                                            callback: function (label, index, labels) {\n                                                return mgBytesToSize(label);\n                                            }\n                                        },\n                                    }]\n                            },\n                            tooltips: {\n                                callbacks: {\n                                    label: function (tooltipItem, data) {\n                                        return mgBytesToSize(tooltipItem.yLabel) + \"/s\";\n                                    }\n                                }\n                            }\n                        }\n                    });\n                    var disk = document.getElementById(\"pm-chart-disk\"+vserverid).getContext('2d');\n                    new Chart(disk, {\n                        type: 'line',\n                        label: 'Dataset',\n                        data: data.disk,\n                        options: {\n                            maintainAspectRatio: false,\n                            scales: {\n                                yAxes: [{\n                                        scaleLabel: {\n                                            display: true,\n                                            labelString: 'Bytes/s'\n                                        },\n                                        ticks: {\n                                            beginAtZero: true,\n                                            callback: function (label, index, labels) {\n                                                return mgBytesToSize(label);\n                                            }\n                                        },\n                                    }]\n                            },\n                            tooltips: {\n                                callbacks: {\n                                    label: function (tooltipItem, data) {\n                                        return mgBytesToSize(tooltipItem.yLabel) + \"/s\";\n                                    }\n                                }\n                            }\n                        }\n                    });\n                                    }else{\n                                        \$(\"#so_graphs_\"+vserverid).show().html(data.result);\n                                    }\n                          }, \"json\");\n\n                      });\n                });\n                </script>\n        ";
		$js .= "<div id=\"proxmoxCloud_Dialog\" style=\"display:none;\"> \n               <table cellspacing=\"2\" cellpadding=\"3\" border=\"0\">\n                         <tbody>\n                          <tr>\n                             <td  width=\"50%\">Target Node:</td>\n                             <td> ";
		$js .= '<select name="proxmoxcloud_node" id="proxmoxcloud_node2">';

		foreach ($nodes as $node) {
			$js .= '<option>' . $node['node'] . '</option>';
		}

		$js .= '</select> </td>';
		$js .= '</tr>' . '<tr><td  width="50%">Online: </td>' . '<td><input type="checkbox" id="proxmox_migrate_online" style="margin-left:-1px;"> </td>' . '</tr>' . '<tbody></table></div>';
		$js .= "<div id=\"proxmoxCloud_Dialog_EditNode\" style=\"display:none;\"> \n               <table cellspacing=\"2\" cellpadding=\"3\" border=\"0\">\n                         <tbody>\n                         <tr>\n                             <td  width=\"50%\">Main Node: </td>\n                             <td id=\"proxmox_editvm_main_node\"></td>\n                         </tr>\n                         <tr>\n                             <td  width=\"50%\">VMID: </td>\n                             <td id=\"proxmox_editvm_vmid\"></td>\n                         </tr>\n                       " . "<tr>\n                             <td  width=\"50%\">Target Node:</td>\n                             <td> ";
		$js .= '<select name="proxmoxcloud_node" id="proxmoxcloud_node3">';

		foreach ($nodes as $node) {
			$js .= '<option>' . $node['node'] . '</option>';
		}

		$js .= '</select> </td>';
		$js .= '<tbody></table></div>';
		$js .= '<div id="proxmoxCloud_Dialog_DeleteVM" style="display:none;"> Are you sure you want delete this VM?' . '</div>';
		$fields = array('<strong>Virtual Servers</strong>' => $js . $style);
		$vservers = $cloud->getVservers(false, true);
		$cron = new ProxmoxCloudCron();
		$cron->updateDB();

		foreach ($vservers as $server) {
			$cron->setTaskContext($params['serviceid'], $server->id);
			$key = 'Server VMID ' . $server->vmid;

			if ($server->vmid == '0') {
				$key = 'Server ID ' . $server->id;
			}

			if ($cron->existActiveTask('createVm') && !$cron->checkActionFinished('createVm')) {
				$fields[$key] = '<span style="color:red">Creating VM in progress. Please try again later.</span>';
				continue;
			}

			if ($cron->existActiveTask('rebuild') && !$cron->checkActionFinished('rebuild')) {
				$fields[$key] = '<span style="color:red">Rebuild VM in progress. Please try again later.</span>';
				continue;
			}

			$disabled = $server->vmid == '0' ? 'disabled=""' : NULL;
			$fields[$key] = '<strong>' . $server->hostname . '</strong> ' . '<input type="button" ' . $disabled . '  class="btn btn-default procmoxcloud_load" data-vserverid="' . $server->id . '" value="Load Status" id="so_load_' . $server->id . '" /> ' . '<input type="button"  class="btn btn-default proxmoxCloudHide" data-vserverid="' . $server->id . '" value="Hide"  id="so_hide_' . $server->id . '" style="display:none"  /> ' . '<input type="button" ' . $disabled . ' class="btn btn-default proxmoxCloud_migrate" data-vserverid="' . $server->id . '" value="Migrate"    /> ' . '<input type="button" ' . $disabled . ' class="btn btn-default proxmoxCloud_edit_node" data-vserverid="' . $server->id . '"  data-vmid="' . $server->vmid . '" data-node="' . $server->node . '"  value="Edit Node"    />' . '                              <input type="button" class="btn btn-default proxmoxCloud_delete_vm" data-vserverid="' . $server->id . '"  data-vmid="' . $server->vmid . '" data-node="' . $server->node . '"  value="Delete VM"    />' . '                               <span id="proxmox_migrate_alert_' . $server->id . '"></span><span><img id="proxmox_migrate_loading_' . $server->id . '" src="../modules/servers/proxmoxCloud/images/loader.gif" style="margin-left: 2px; display: none;">' . '                               <div id="so_' . $server->id . '" class="so_stats"> </div>';
		}

		$tblIPs = "<div class=\"tablebg\">\n                     <div id=\"proxmox_add_ip_alert\" style=\"background-color: #FFFFFF; padding: 6px; margin-top:0px; display:none\"></div>\n                     <table id=\"proxmoxvps_tblips\" class=\"datatable\" cellspacing=\"1\" cellpadding=\"3\" border=\"0\" width=\"100%\">\n                     <thead><tr><th>VMID</th><th>IP</th> <th>MAC Address </th> <th>Subnet Mask</th> <th>Gateway</th><th></th></tr></thead>";
		$select_vserver = '';

		foreach ($vservers as $server) {
			$select_vserver .= '<option value="' . $server->id . '">' . $server->vmid . ' (' . $server->hostname . ')</option>';

			foreach ($server->ips as $ip) {
				$tblIPs .= '<tr><td>' . $server->vmid . '</td><td>' . $ip->ip . '</td><td>' . $ip->mac_address . '</td> <td>' . $ip->subnet_mask . '</td><td>' . $ip->gateway . "</td>\n                            <td style=\"text-align:center;\"><a href=\"#\" class=\"remove_ip\" rel=\"" . $ip->id . '" data-ip="' . $ip->ip . '" data-vserverid="' . $server->id . "\" ><img width=\"16\" height=\"16\" border=\"0\" title=\"Return IP to IPs pool\" src=\"../modules/servers/proxmoxCloud/images/delete.png\"></a></td>\n                             </tr>";
			}
		}

		$tblIPs .= '<tr style="display:none;" id="noips"><td colspan="6">No Records Found</td></tr>';
		$tblIPs .= '</table>';
		$tblIPs .= "\n                 <div id=\"proxmoxVPS_addip_form\" style=\"display:none; background-color: #FFFFFF; padding: 6px; margin-top:0px;\">\n\n                     <h2>Add New IP</h2>\n\n                     <table class=\"form\"  cellspacing=\"2\" cellpadding=\"3\" border=\"0\" width=\"50%\">\n                         <tbody>\n                          <tr>\n                             <td class=\"fieldlabel\" width=\"20%\">VMID</td>\n                             <td class=\"fieldarea\"><select name=\"proxmoxcloud_ip_vserverid\" id=\"proxmoxcloud_ip_vserverid\" style=\"width:235px;\">" . $select_vserver . "</select></td>\n                         </tr>\n                         <tr>\n                             <td class=\"fieldlabel\" width=\"20%\">IP</td>\n                             <td class=\"fieldarea\"><input id=\"proxmoxVPS_input_ip\" type=\"text\" size=\"30\" value=\"\" name=\"customfield[2]\"></td>\n                         </tr>\n                         <tr>\n                             <td class=\"fieldlabel\" width=\"20%\">MAC Address</td>\n                             <td class=\"fieldarea\"><input id=\"proxmoxVPS_input_mac\" type=\"text\" size=\"30\" value=\"auto\" name=\"customfield[2]\"></td>\n                         </tr>\n                         <tr>\n                             <td class=\"fieldlabel\" width=\"20%\">Subnet Mask</td>\n                             <td class=\"fieldarea\"><input id=\"proxmoxVPS_input_subnet_mask\" type=\"text\" size=\"30\" value=\"\" name=\"customfield[2]\"></td>\n                         </tr>\n                         <tr>\n                             <td class=\"fieldlabel\" width=\"20%\">Gateway</td>\n                             <td class=\"fieldarea\"><input id=\"proxmoxVPS_input_gateway\" type=\"text\" size=\"30\" value=\"\" name=\"customfield[2]\"></td>\n                         </tr>\n                         </tbody>\n                     </table>\n                     <br/>\n                     <div style=\"text-align:center; width:50%;\">\n                         <input class=\"btn btn-default\" type=\"button\" value=\"Save Changes\" id=\"proxmoxVPS_addip_submit\">\n                         <input class=\"btn btn-default\" type=\"button\" onclick=\"\" value=\"Cancel\" style=\"margin-left:3px;\" id=\"proxmoxVPS_addip_cancel\">\n\n                     </div>\n                 </div>\n                 <div class=\"proxmoxVPS_addip\" style=\"padding:5px 25px;\">  <a href=\"#\"  class=\"proxmoxVPS_addip\" > Add New IP</a> </div>\n            </div>\n            ";
		$fields['IP Addresses'] = $tblIPs;
		$cron = new ProxmoxCloudCron();
		$cron->updateDB();
		$cron->setTaskContext($params['serviceid']);
		$tableHeaders = array('Task', 'Created', 'Last Update', 'Attempts', 'Message', 'Status', 'Actions');
		$tableRows = array();
		$i = 1;

		foreach ($cron->listActiveTasks() as $task) {
			if ($task->locked == 1) {
				if (100 < time() - strtotime($task->lastAttemptDate)) {
					$status = "\n                        Task Stuck from: " . $task->lastAttemptDate . '<a class="unlock_task" href="#" rel="' . $task->UUID . '" num=' . $i . ">\n                            Unlock\n\n                        </a> <img src=\"../modules/servers/proxmoxCloud/images/ajax-loader.gif\" id=\"proxmox_ajax3_" . $i . '" style="display:none;">';
				}
				else {
					$status = 'Current in progress';
				}
			}
			else {
				$status = 'Waiting for processing';
			}

			$delete = "           \n                        <a class=\"delete_task\"  href=\"\" rel=\"" . $task->UUID . '" num=' . $i . ">\n                            <img width=\"16\" border=\"0\" height=\"16\" title=\"Remove\" src=\"../modules/servers/proxmoxCloud/images/delete.png\">\n\n                        </a> <img src=\"../modules/servers/proxmoxCloud/images/ajax-loader.gif\" id=\"proxmox_ajax2_" . $i . '" style="display:none;">';
			$tableRows[] = array($task->action, $task->createDate, $task->lastAttemptDate == '0000-00-00 00:00:00' ? 'Not processed yet' : $task->lastAttemptDate, $task->attempt, empty($task->message) ? 'Not processed yet' : $task->message, $status, $delete);
			++$i;
		}

		if ($tableRows) {
			$html = "<div id=\"proxmoxCloud_cron_alert\" style=\" padding: 6px; margin-top:0px; display:none\"></div>\n                     <table width=\"100%\" class=\"datatable\">";
			$html .= '<thead>';
			$html .= '<tr>';
			$html .= '<th>Task</th>';
			$html .= '<th>Created</th>';
			$html .= '<th>Last Update</th>';
			$html .= '<th>Attempts</th>';
			$html .= '<th>Message</th>';
			$html .= '<th>Status</th>';
			$html .= '<th style="text-align:center; width:10px;">Remove</th>';
			$html .= '</tr>';
			$html .= '</thead>';

			foreach ($tableRows as $row) {
				$html .= '<tr><td>' . $row[0] . '</td>';
				$html .= '<td>' . $row[1] . '</td>';
				$html .= '<td>' . $row[2] . '</td>';
				$html .= '<td style="text-align:center;">' . $row[3] . '</td>';
				$html .= '<td>' . $row[4] . '</td>';
				$html .= '<td>' . $row[5] . '</td>';
				$html .= '<td style="text-align:center;">' . $row[6] . '</td>';
				$html .= '</tr>';
			}

			$html .= '<tr><td id="no_task" colspan="7" style="display:none;">You do not have any scheduled tasks</td></tr></table>';
		}
		else {
			$html = 'You do not have any scheduled tasks';
		}

		$html2 = "\n\n                 <div id=\"proxmoxVPS_importvm_form\" style=\"display:none; background-color: #FFFFFF; padding: 6px; margin-top:0px;\">\n                  <h2>Import VM</h2>";

		if ($product->getConfig('virtualization_type') == 'OpenVZ') {
			$html2 .= '<span>Incorrect password will block an access to the console</span><br/><br/>';
		}

		$html2 .= "<div id=\"proxmox_importvm_alert\" style=\"background-color: rgb(255, 255, 255); padding: 0px; margin-top: -5px; margin-bottom:10px; display:none; display:none;\"></div>\n\n                     <table class=\"form\"  cellspacing=\"2\" cellpadding=\"3\" border=\"0\" width=\"50%\">\n                         <tbody>\n                          <tr>\n                             <td class=\"fieldlabel\" width=\"20%\">Node</td>\n                             <td class=\"fieldarea\">\n                             <select name=\"proxmoxcloud_node\" id=\"proxmoxcloud_node\" style=\"width:235px;\">";

		foreach ($nodes as $node) {
			$html2 .= '<option>' . $node['node'] . '</option>';
		}

		$html2 .= '</select>';
		$html2 .= " </td>\n                         </tr>\n                         <tr>\n                             <td class=\"fieldlabel\" width=\"20%\">VMID</td>\n                             <td class=\"fieldarea\"><input id=\"proxmoxVPS_input_vmid\" type=\"text\" size=\"30\" value=\"\" name=\"vmid\" style=\"width:230px;\"></td>\n                         </tr>";

		if ($product->getConfig('virtualization_type') == 'OpenVZ') {
			$html2 .= "<tr>\n                             <td class=\"fieldlabel\" width=\"20%\">Password</td>\n                             <td class=\"fieldarea\"><input id=\"proxmoxVPS_input_password\" type=\"text\" size=\"30\" value=\"\" name=\"password\" style=\"width:230px;\"></td>\n                         </tr>";
		}

		$html2 .= "</tbody>\n                     </table>\n                     <br/>\n                     <div style=\"text-align:center; width:50%;\">\n                         <input class=\"btn btn-primary\" type=\"button\" value=\"Save Changes\" id=\"proxmoxVPS_importvm_submit\">\n                         <input class=\"btn btn-default\" type=\"button\" onclick=\"\" value=\"Cancel\" style=\"margin-left:3px;\" id=\"proxmoxVPS_importvm_cancel\">\n                         <img id=\"proxmox_importvm_loading\" src=\"../modules/servers/proxmoxCloud/images/loader.gif\" style=\"margin-left: 2px; display: none;\">\n                     </div>\n                 </div>\n                 <div class=\"proxmoxVPS_importVM\" style=\"padding:5px 25px;\">  <a href=\"#\"  class=\"proxmoxVPS_importvm\" >Import VM</a> </div>\n            </div>\n            ";
		$fields['Import VM'] = $html2;
		$fields['Scheduled Tasks'] = $html;
		return $fields;
	}
	catch (Exception $e) {
		return $e->getMessage();
	}
}

function proxmoxCloud_ClientArea($params)
{
	if ($_GET['modop'] == 'custom' && $_GET['a'] == 'management') {
		return NULL;
	}

	try {
		require_once 'Loader.php';
		$loader = new \MGProvision\ProxmoxCloud\Loader();

		if (isset($_REQUEST['page'])) {
			$_REQUEST['page'] = 'home';
		}

		return \MGProvision\ProxmoxCloud\Provision::clientarea($params);
	}
	catch (Exception $ex) {
		return array(
	'templatefile' => 'templates' . DS . 'clientarea' . DS . 'default' . DS . 'fatal',
	'breadcrumb'   => ' > <a href="#">Management</a>',
	'vars'         => array('message' => $ex->getMessage())
	);
	}
}

function proxmoxCloud_management($params)
{
	try {
		require_once 'Loader.php';
		$loader = new \MGProvision\ProxmoxCloud\Loader();
		$product = new proxmoxCloud_Product($params['packageid']);
		$whmcs6 = isset($GLOBALS['CONFIG']['Version']) && '6.0.0' <= $GLOBALS['CONFIG']['Version'];
		$isSixTemplate = false;
		if ($whmcs6 && \MGProvision\ProxmoxCloud\Provision::isTemplateSix()) {
			$isSixTemplate = true;
			add_hook('ClientAreaPrimarySidebar', 1, function(\WHMCS\View\Menu\Item $primarySidebar) use($params) {
				$panel = $primarySidebar->getChild('Service Details Overview');

				if (is_a($panel, 'WHMCS\\View\\Menu\\Item')) {
					$panel = $panel->getChild('Information');

					if (is_a($panel, 'WHMCS\\View\\Menu\\Item')) {
						$panel->setUri('clientarea.php?action=productdetails&id=' . $params['serviceid']);
						$panel->setAttributes(array());
					}
				}

				$panel = \MGProvision\ProxmoxCloud\Provision::getSidebar('manageSevers', $params);
				$sidebar = $primarySidebar->addChild($panel['id'], array('label' => $panel['label'], 'uri' => $panel['uri'], 'icon' => $panel['icon'], 'order' => 20));
				$sidebar->setBodyHtml($panel['html']);

				if (isset($_GET['vm'])) {
					$panel = \MGProvision\ProxmoxCloud\Provision::getSidebar('managevm', $params);
					$sidebar = $primarySidebar->addChild($panel['id'], array('label' => $panel['label'], 'uri' => $panel['uri'], 'icon' => $panel['icon']));
					$sidebar->moveToBack();
					$sidebar->setBodyHtml($panel['html']);
					$panel = \MGProvision\ProxmoxCloud\Provision::getSidebar('additionalTools', $params);
					$sidebar = $primarySidebar->addChild($panel['id'], array('label' => $panel['label'], 'uri' => $panel['uri'], 'icon' => $panel['icon'], 'order' => 30));
					$sidebar->setBodyHtml($panel['html']);
				}
			});
		}
		else {
			$panel = \MGProvision\ProxmoxCloud\Provision::getSidebar('manageAccount', $params);
			$manageAccount = $panel['html'];
		}

		$out = \MGProvision\ProxmoxCloud\Provision::clientarea($params);
		$out['vars']['manageAccount'] = $manageAccount;
		$out['vars']['isTemplateSix'] = $isSixTemplate;
		return $out;
	}
	catch (Exception $ex) {
		return array(
	'templatefile' => 'templates' . DS . 'clientarea' . DS . 'default' . DS . 'fatal',
	'breadcrumb'   => ' > <a href="#">Management</a>',
	'vars'         => array('message' => $ex->getMessage())
	);
	}
}

function proxmoxCloud_AdminLink($params)
{
	$id = uniqid();
	$scr = "\n            <script type=\"text/javascript\">\n            \$(document).ready(function(){\n                    \$(\".proxmoxCloud_connection" . $id . "\").click(function(){\n                            var \$a = \$(this);\n                            var \$div = \$(this).closest(\"div\");\n                            \$.post(\"../clientarea.php?proxmoxcloud_ajax=1\", {\"proxmoxcloud_act\":\"test_connection\", \"serverip\":\$a.data(\"serverip\"), \"serverhostname\":\$a.data(\"serverhostname\"), \"serverusername\":\$a.data(\"serverusername\"), \"serverpassword\":\$a.data(\"serverpassword\"), \"serversecure\":\$a.data(\"serversecure\"), \"serveraccesshash\":\$a.data(\"serveraccesshash\")}, function(res){\n                                    \$div.css(\"color\", res.success == \"1\" ? \"green\" : \"red\").html(res.result);\n                            }, \"json\");\n                            \$div.html(\"<img src=\\\"../modules/servers/proxmoxCloud/images/loader.gif\\\" />\");\n                            return false;\n                    });\n            });\n            </script>\n            ";
	return $scr . '<div style="width:200px;"><a href="" class="proxmoxCloud_connection' . $id . '" data-serverip="' . $params['serverip'] . '" data-serverhostname="' . $params['serverhostname'] . '" data-serverusername="' . $params['serverusername'] . '" data-serverpassword="' . $params['serverpassword'] . '" data-serversecure="' . $params['serversecure'] . '" data-serveraccesshash="' . $params['serveraccesshash'] . '">Test Connection</a></div>';
}

function proxmoxCloud_UsageUpdate($params)
{
	proxmoxCloud_debug();
	$API = new proxmoxCloud_API(proxmoxCloud_getHostname($params, false), $params['serverusername'], $params['serveraccesshash'], $params['serverpassword']);

	try {
		$API->load();
		$serverid = $params['serverid'];
		$hosting = \MGProvision\ProxmoxCloud\libs\PdoWrapper::query("SELECT h.*, p.name\n                            FROM `tblhosting` h\n                            LEFT JOIN `tblproducts` p ON (h.packageid=p.id)\n                            WHERE h.server=?  \n                            AND h.domainstatus =?\n                            ", array($serverid, 'Active'));
		$hosting = \MGProvision\ProxmoxCloud\libs\PdoWrapper::fetchArray($hosting);
		$today = date('d');

		foreach ($hosting as $h) {
			$product = new proxmoxCloud_Product($h['packageid']);
			$usageUpdate = $product->getConfig('usageUpdate');
			if (!$usageUpdate || $usageUpdate == 'daily') {
				if ($today == '01') {
					\MGProvision\ProxmoxCloud\libs\PdoWrapper::query('UPDATE tblhosting SET bwusage=0 WHERE id=?', array($h['id']));
				}

				if ($h['lastupdate'] == '0000-00-00 00:00:00') {
					\MGProvision\ProxmoxCloud\libs\PdoWrapper::query('UPDATE tblhosting SET  `lastupdate`=NOW() WHERE id=?', array($h['id']));
					continue;
				}

				$lastupdate = new DateTime($h['lastupdate']);
				$dnow = new DateTime();
				$dDiff = $lastupdate->diff($dnow);

				if ($dDiff->days < 1) {
					continue;
				}
			}

			if ($product->getConfig('debug_mode')) {
				$API->whmcsDebugMode(true);
			}

			$cloud = new proxmoxCloud($h['id']);
			$cloud->setApi($API);
			$cloud->setProduct($product);
			$vservers = $cloud->getVservers();
			$net = 0;
			$diskusage = 0;
			$netin = array();
			$netout = array();
			$backup_delete_older_than = (int) $product->getConfig('backup_delete_older_than');

			foreach ($vservers as $vserver) {
				if ($vserver->vmid == '0') {
					continue;
				}

				if (!$usageUpdate || $usageUpdate == 'daily') {
					$status = $cloud->getVmidStatus($vserver);

					if ($vserver->type == 'openvz') {
						$rrdata = $API->get('/nodes/' . $vserver->node . '/openvz/' . $vserver->vmid . '/rrddata', array('timeframe' => 'day', 'cf' => 'AVERAGE'));
					}
					else if ($vserver->type == 'kvm') {
						$rrdata = $API->get('/nodes/' . $vserver->node . '/qemu/' . $vserver->vmid . '/rrddata', array('timeframe' => 'day', 'cf' => 'AVERAGE'));
					}
					else {
						if ($vserver->type == 'lxc') {
							$rrdata = $API->get('/nodes/' . $vserver->node . '/lxc/' . $vserver->vmid . '/rrddata', array('timeframe' => 'day', 'cf' => 'AVERAGE'));
						}
					}

					if (isset($status['disk'])) {
						$diskusage += $status['disk'];
					}

					$total = 0;
					$rrdataLast = array_slice($rrdata, -48);
					$lastupdate = new DateTime($vserver->created_at);

					foreach ($rrdataLast as $rrd) {
						if ($rrd['time'] < $lastupdate->getTimestamp()) {
							continue;
						}

						$total += $rrd['netin'] + $rrd['netout'];
					}

					if (1000000000 < $total) {
						$total = 0;
					}

					$net += $total;
					$net = $net * 1800;
				}

				$backupFiles = $cloud->getBackupFiles($vserver);
				$size = 0;
				$files = 0;

				foreach ($backupFiles as $k => $backupfile) {
					$size += $backupfile['size'];
					++$files;

					if (!$backup_delete_older_than) {
						continue;
					}

					preg_match('/[0-9]{4}_[0-9]{2}_[0-9]{2}/', $backupfile['volid'], $matches);
					$dateCreated = str_replace('_', '-', $matches[0]);

					if (!$dateCreated) {
						continue;
					}

					$dateCreated = new DateTime($dateCreated);
					$now = new DateTime();
					$dDiff = $dateCreated->diff($now);

					if ($backup_delete_older_than < $dDiff->days) {
						$cloud->dellBackupFile($backupfile['volid'], $vserver);
					}
				}

				$vserver->update(array('backups_files_usage' => $files, 'backups_size_usage' => MG_byteFormat2($size, 'GB')));
			}

			if (!$usageUpdate || $usageUpdate == 'daily') {
				$bwusage = (int) MG_byteFormat2($net, 'MB');

				if ($diskusage == '0') {
					$statsCurr = $cloud->getVserversStats();
					$statsCurr['bytes_storage'] += $statsCurr['bytes_hdds'];
					$diskusage = $statsCurr['bytes_storage'];
					unset($statsCurr);
				}

				$diskusage = (int) MG_byteFormat2($diskusage, 'MB');
				\MGProvision\ProxmoxCloud\libs\PdoWrapper::query('UPDATE tblhosting SET diskusage=?, bwusage=bwusage+?, `lastupdate`=NOW() WHERE id=?', array($diskusage, $bwusage, $h['id']));
			}

			$hosting = new proxmoxCloud_Hosting($h['id']);
			$hosting->updateHostingLimit($product->getConfig('default_storage_limit'), $product->getConfig('default_bandwidth_limit'));
			$params['serviceid'] = $h['id'];
			$usageUpdate = new \MGProvision\ProxmoxCloud\controllers\admin\UsageUpdateController($params);
			$usageUpdate->setProduct($product);
			$usageUpdate->api();
			$usageUpdate->backups();
			unset($vservers);
			unset($cloud);
			unset($product);
			unset($hosting);
		}
	}
	catch (Exception $e) {
		return $e->getMessage();
	}
}

function proxmoxCloud_TestConnection($params)
{
	try {
		require_once 'Loader.php';
		$loader = new \MGProvision\ProxmoxCloud\Loader();
		if ($params['serverip'] && $params['serverhostname']) {
			$api = new \MGProvision\Proxmox\v2\Api($params['serverip'], $params['serverusername'], $params['serveraccesshash'], $params['serverpassword']);
			unset($api);
			$api = new \MGProvision\Proxmox\v2\Api($params['serverhostname'], $params['serverusername'], $params['serveraccesshash'], $params['serverpassword']);
		}
		else {
			$api = \MGProvision\Proxmox\v2\Factory::api($params);
			$api->debug();
		}

		return array('success' => true);
	}
	catch (Exception $e) {
		return array('error' => $e->getMessage());
	}
}

function proxmoxCloud_AdminCustomButtonArray($params)
{
	require_once 'Loader.php';
	new \MGProvision\ProxmoxCloud\Loader();
	$product = new proxmoxCloud_Product($params['pid']);
	$buttons = array('Change User Role' => 'ChangeUser');

	if ($product->getConfig('debug_mode')) {
		$buttons['Debug'] = 'cron';
	}

	return $buttons;
}

function proxmoxCloud_ChangeUser($params)
{
	if (isset($_SERVER['SERVER_NAME'])) {
		$license_check = proxmox_cloud_license_2259();

		if ($license_check['status'] != 'Active') {
			$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
			return $error_message;
		}
	}

	require_once 'Loader.php';
	$loader = new \MGProvision\ProxmoxCloud\Loader();
	$action = lcfirst(preg_replace('/(.*)\\_/', '', 'proxmoxCloud_ChangeUser'));
	return \MGProvision\ProxmoxCloud\Provision::accountAction($action, $params);
}

function proxmoxCloud_ChangePackage($params)
{
	if (isset($_SERVER['SERVER_NAME'])) {
		$license_check = proxmox_cloud_license_2259();

		if ($license_check['status'] != 'Active') {
			$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
			return $error_message;
		}
	}

	require_once 'Loader.php';
	$loader = new \MGProvision\ProxmoxCloud\Loader();
	$action = lcfirst(preg_replace('/(.*)\\_/', '', 'proxmoxCloud_ChangePackage'));
	return \MGProvision\ProxmoxCloud\Provision::accountAction($action, $params);
}

function proxmoxCloud_cron($params)
{
	try {
		error_reporting(1);
		ini_set('display_errors', '1');
		$cron = new ProxmoxCloudCron();
		$cron->updateDB();
		$cron->executeTasks();
		$cron->usageUpdate();

		if ($ex = $cron->getLastException()) {
			echo '<pre>';
			print_r($ex);
			echo '</pre>';
			exit();
		}

		return 'success';
	}
	catch (Exception $ex) {
		return $ex->getMessage();
	}
}

if (!defined('DS')) {
	define('DS', DIRECTORY_SEPARATOR);
}

if (isset($_REQUEST['_debug']) && $_REQUEST['_debug'] == 'turnon') {
	$_SESSION['mg_proxmoxcloud_debug'] = 1;
}
else {
	if (isset($_REQUEST['_debug']) && $_REQUEST['_debug'] == 'turnoff') {
		$_SESSION['mg_proxmoxcloud_debug'] = NULL;
	}
}

if (!class_exists('MGProvision\\ProxmoxCloud\\Loader')) {
	require_once dirname(__FILE__) . DS . 'Loader.php';
	new \MGProvision\ProxmoxCloud\Loader();
}

include_once dirname(__FILE__) . DS . 'utility.php';
proxmoxCloud_load();
proxmoxCloud_debug();

if (!function_exists('proxmoxCloud_ClientAreaCustomButtonArray')) {
	function proxmoxCloud_ClientAreaCustomButtonArray($params)
	{
		proxmoxCloud_debug();
		$_LANG = proxmoxCloud_getLang();
		return array($_LANG['cloud']['management'] => 'management');
	}
}

?>
