<?php
//dezend by http://www.yunlu99.com/
class proxmox_vps_license_585PDOWrapper
{
	static private $pdoConnection;

	static private function getDbConnection()
	{
		if (class_exists('Illuminate\\Database\\Capsule\\Manager')) {
			return \Illuminate\Database\Capsule\Manager::connection()->getPdo();
		}

		if (self::$pdoConnection === NULL) {
			self::$pdoConnection = self::setNewConnection();
		}

		return self::$pdoConnection;
	}

	static private function setNewConnection()
	{
		try {
			$includePath = ROOTDIR . DIRECTORY_SEPARATOR . 'configuration.php';

			if (file_exists($includePath)) {
				require $includePath;
			}
			else {
				throw new Exception('No configuration file found');
			}

			$connection = new PDO(sprintf('mysql:host=%s;dbname=%s;port=%s;charset=utf8', $db_host, $db_name, $db_port ? $db_port : 3360), $db_username, $db_password);
			$connection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			return $connection;
		}
		catch (PDOException $exc) {
		}
	}

	static public function query($query, $params = array())
	{
		$statement = self::getDbConnection()->prepare($query);
		$statement->execute($params);
		return $statement;
	}

	static public function real_escape_string($string)
	{
		return substr(self::getDbConnection()->quote($string), 1, -1);
	}

	static public function fetch_assoc($query)
	{
		return $query->fetch(PDO::FETCH_ASSOC);
	}

	static public function fetch_array($query)
	{
		return $query->fetch(PDO::FETCH_BOTH);
	}

	static public function fetch_object($query)
	{
		return $query->fetch(PDO::FETCH_OBJ);
	}

	static public function num_rows($query)
	{
		$query->fetch(PDO::FETCH_BOTH);
		return $query->rowCount();
	}

	static public function insert_id()
	{
		return self::getDbConnection()->lastInsertId();
	}

	static public function errorInfo()
	{
		$tmpErr = self::getDbConnection()->errorInfo();
		if ($tmpErr[0] && $tmpErr[0] !== '00000') {
			return $tmpErr;
		}

		return false;
	}

	static public function mysql_get_array($query, $params = array())
	{
		$qRes = self::query($query, $params);
		$arr = array();

		while ($row = self::fetch_assoc($qRes)) {
			$arr[] = $row;
		}

		return $arr;
	}

	static public function mysql_get_row($query, $params = array())
	{
		$qRes = self::query($query, $params);
		return self::fetch_assoc($qRes);
	}
}

function proxmox_vps_license_585()
{
	global $CONFIG;
	$moduleVersionFile = __DIR__ . '/moduleVersion.php';
	$moduleVersion = '';

	if (file_exists($moduleVersionFile)) {
		require $moduleVersionFile;
	}

	$whmcsVersion = $CONFIG['Version'];
	$results = array('status' => 'Unknown Error', 'description' => '');
	$proxmox_vps_licensekey = '';

	if (!file_exists(dirname(__FILE__) . DIRECTORY_SEPARATOR . 'license.php')) {
		$results['status'] = 'Error';
		$results['description'] = 'Proxmox VPS: Unable to find license.php file. Please rename file license_RENAME.php to license.php';
		return $results;
	}

	require dirname(__FILE__) . DIRECTORY_SEPARATOR . 'license.php';
	$licensekey = $proxmox_vps_licensekey;
	$query_result = proxmox_vps_license_585PDOWrapper::query('SELECT value FROM tblconfiguration WHERE setting = \'proxmox_vps_localkey\'');

	if ($query_row = proxmox_vps_license_585PDOWrapper::fetch_assoc($query_result)) {
		$localkey = $query_row['value'];
	}

	$whmcsurl = 'http://modulesgarden.com/manage/';
	$backupwhmcsurl = 'http://licensing.modulesgarden.com';
	$whmcshostname = 'modulesgarden.com';
	$licensing_secret_key = '7b9012a73df99fb2c6ae8e523df99fb2c6ae8';
	$check_token = time() . md5(mt_rand(1000000000, 9999999999) . $licensekey);
	$checkdate = date('Ymd');
	$usersip = isset($_SERVER['SERVER_ADDR']) ? $_SERVER['SERVER_ADDR'] : $_SERVER['LOCAL_ADDR'];
	$localkeydays = 1;
	$allowcheckfaildays = 4;
	$domain = $_SERVER['SERVER_NAME'];
	$dirpath = dirname(__FILE__);
	$verifyfilepath = 'modules/servers/licensing/verify.php';
	$localkeyvalid = false;

	if ($localkey) {
		$localkey = str_replace("\n", '', $localkey);
		$localdata = substr($localkey, 0, strlen($localkey) - 32);
		$md5hash = substr($localkey, strlen($localkey) - 32);

		if ($md5hash == md5($localdata . $licensing_secret_key)) {
			$localdata = strrev($localdata);
			$md5hash = substr($localdata, 0, 32);
			$localdata = substr($localdata, 32);
			$localdata = base64_decode($localdata);
			$localkeyresults = unserialize($localdata);
			$originalcheckdate = $localkeyresults['checkdate'];

			if ($md5hash == md5($originalcheckdate . $licensing_secret_key)) {
				$localexpiry = date('Ymd', mktime(0, 0, 0, date('m'), date('d') - $localkeydays, date('Y')));

				if ($localexpiry < $originalcheckdate) {
					$localkeyvalid = true;
					$results = $localkeyresults;
					$validdomains = explode(',', $results['validdomain']);
					if (!empty($_SERVER['SERVER_NAME']) && !in_array($_SERVER['SERVER_NAME'], $validdomains)) {
						$localkeyvalid = false;
						$localkeyresults['status'] = 'Invalid';
						$results = array();
					}

					$validips = explode(',', $results['validip']);
					if (!empty($usersip) && !in_array($usersip, $validips)) {
						$localkeyvalid = false;
						$localkeyresults['status'] = 'Invalid';
						$results = array();
					}

					$validdirs = explode(',', $results['validdirectory']);

					if (!in_array($dirpath, $validdirs)) {
						$localkeyvalid = false;
						$localkeyresults['status'] = 'Invalid';
						$results = array();
					}
				}
			}
		}
	}

	if (!$localkeyvalid) {
		$postfields = array('licensekey' => $licensekey, 'domain' => $domain, 'ip' => $usersip, 'dir' => $dirpath, 'whmcs' => $whmcsVersion, 'module' => $moduleVersion);

		if ($check_token) {
			$postfields['check_token'] = $check_token;
		}

		$query_string = http_build_query($postfields);
		$http_code = 0;

		if (function_exists('curl_exec')) {
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $whmcsurl . $verifyfilepath);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $query_string);
			curl_setopt($ch, CURLOPT_TIMEOUT, 5);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			$data = curl_exec($ch);
			$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
			curl_close($ch);
		}
		else {
			$fp = fsockopen($whmcshostname, 80, $errno, $errstr, 5);

			if ($fp) {
				$newlinefeed = "\r\n";
				$header = 'POST ' . $whmcsurl . $verifyfilepath . ' HTTP/1.0' . $newlinefeed;
				$header .= 'Host: ' . $whmcsurl . $newlinefeed;
				$header .= 'Content-type: application/x-www-form-urlencoded' . $newlinefeed;
				$header .= 'Content-length: ' . @strlen($query_string) . $newlinefeed;
				$header .= 'Connection: close' . $newlinefeed . $newlinefeed;
				$header .= $query_string;
				$data = '';
				@stream_set_timeout($fp, 5);
				@fputs($fp, $header);
				$status = @socket_get_status($fp);

				while (!@feof($fp) && $status) {
					$data .= @fgets($fp, 1024);
					$status = @socket_get_status($fp);
				}

				@fclose($fp);
			}
		}

		list($headerline) = explode("\r\n", $data, 2);

		if (preg_match('/(?<http>[A-Z]{4,5})\\/(?<http_version>[0-9\\.]+) (?<http_code>[0-9]{3})/', trim($headerline), $headers)) {
			$http_code = $headers['http_code'];
		}

		if (!$data || $http_code != '200') {
			if (function_exists('curl_exec')) {
				$ch = curl_init();
				curl_setopt($ch, CURLOPT_URL, $backupwhmcsurl);
				curl_setopt($ch, CURLOPT_POST, 1);
				curl_setopt($ch, CURLOPT_POSTFIELDS, $query_string);
				curl_setopt($ch, CURLOPT_TIMEOUT, 5);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
				$data = curl_exec($ch);
				$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
				curl_close($ch);
			}
			else {
				$fp = fsockopen($whmcshostname, 80, $errno, $errstr, 5);

				if ($fp) {
					$newlinefeed = "\r\n";
					$header = 'POST ' . $backupwhmcsurl . ' HTTP/1.0' . $newlinefeed;
					$header .= 'Host: ' . $backupwhmcsurl . $newlinefeed;
					$header .= 'Content-type: application/x-www-form-urlencoded' . $newlinefeed;
					$header .= 'Content-length: ' . @strlen($query_string) . $newlinefeed;
					$header .= 'Connection: close' . $newlinefeed . $newlinefeed;
					$header .= $query_string;
					$data = '';
					@stream_set_timeout($fp, 5);
					@fputs($fp, $header);
					$status = @socket_get_status($fp);

					while (!@feof($fp) && $status) {
						$data .= @fgets($fp, 1024);
						$status = @socket_get_status($fp);
					}

					@fclose($fp);
				}
			}

			list($headerline) = explode("\r\n", $data, 2);

			if (preg_match('/(?<http>[A-Z]{4,5})\\/(?<http_version>[0-9\\.]+) (?<http_code>[0-9]{3})/', trim($headerline), $headers)) {
				$http_code = $headers['http_code'];
			}
		}

		if (!$data || $http_code != '200') {
			$localexpiry = date('Ymd', mktime(0, 0, 0, date('m'), date('d') - ($localkeydays + $allowcheckfaildays), date('Y')));
			$lenght = strlen($localkeyresults['checktoken']) - 32;
			$timestamp = substr($localkeyresults['checktoken'], 0, $lenght);
			$originalcheckdate = date('Ymd', $timestamp);

			if ($localexpiry < $originalcheckdate) {
				$results = $localkeyresults;
				$checkdate = $results['checkdate'];
				$check_token = $results['checktoken'];
			}
			else {
				$results['status'] = 'Invalid';
				$results['description'] = 'Remote Check Failed';
				return $results;
			}
		}
		else {
			preg_match_all('/<(.*?)>([^<]+)<\\/\\1>/i', $data, $matches);
			$results = array();

			foreach ($matches[1] as $k => $v) {
				$results[$v] = $matches[2][$k];
			}
		}

		if (!is_array($results)) {
			$results['status'] = 'Invalid';
			$results['description'] = 'Invalid License Server Response';
			return $results;
		}

		if ($results['md5hash']) {
			if ($results['md5hash'] != md5($licensing_secret_key . $check_token)) {
				$results['status'] = 'Invalid';
				$results['description'] = 'MD5 Checksum Verification Failed';
				return $results;
			}
		}

		if ($results['status'] == 'Active') {
			$results['checkdate'] = $checkdate;
			$results['checktoken'] = $check_token;
			$data_encoded = serialize($results);
			$data_encoded = base64_encode($data_encoded);
			$data_encoded = md5($checkdate . $licensing_secret_key) . $data_encoded;
			$data_encoded = strrev($data_encoded);
			$data_encoded = $data_encoded . md5($data_encoded . $licensing_secret_key);
			$data_encoded = wordwrap($data_encoded, 80, "\n", true);
			$results['localkey'] = $data_encoded;
		}

		$results['remotecheck'] = true;
	}

	unset($postfields);
	unset($data);
	unset($matches);
	unset($whmcsurl);
	unset($licensing_secret_key);
	unset($checkdate);
	unset($usersip);
	unset($localkeydays);
	unset($allowcheckfaildays);
	unset($md5hash);
	if (isset($results['localkey']) && $results['localkey'] != '') {
		$query_result = proxmox_vps_license_585PDOWrapper::query('SELECT value FROM tblconfiguration WHERE setting = \'proxmox_vps_localkey\'');
		$query_row = proxmox_vps_license_585PDOWrapper::fetch_assoc($query_result);

		if (isset($query_row['value'])) {
			proxmox_vps_license_585PDOWrapper::query('UPDATE tblconfiguration SET value = \'' . proxmox_vps_license_585PDOWrapper::real_escape_string($results['localkey']) . '\' WHERE setting = \'proxmox_vps_localkey\'');
		}
		else {
			proxmox_vps_license_585PDOWrapper::query('INSERT INTO tblconfiguration (setting,value) VALUES (\'proxmox_vps_localkey\',\'' . proxmox_vps_license_585PDOWrapper::real_escape_string($results['localkey']) . '\')');
		}
	}

	switch ($results['status']) {
	case 'Active':
		$results['description'] = 'Your module license is active.';
		break;

	case 'Invalid':
		$results['description'] = 'Your module license is invalid.';
		break;

	case 'Expired':
		$results['description'] = 'Your module license has expired.';
		break;

	case 'Suspended':
		$results['description'] = 'Your module license is suspended.';
		break;

	case 'Error':
		if (!$results['description']) {
			$results['description'] = 'Connection not possible. Please report your server IP to contact@modulesgarden.com';
		}

		break;

	default:
		$results['description'] = 'Connection not possible. Please report your server IP to contact@modulesgarden.com';
		break;
	}

	return $results;
}

function proxmoxVPS_ConfigOptions($prameters = array())
{
	proxmoxVPS_debug();
	if (isset($_REQUEST['action']) && $_REQUEST['action'] != 'save' && preg_match('/configproducts.php/', $_SERVER['SCRIPT_FILENAME'])) {
		$data = array();
		$data['mode'] = 'advanced';
		$data['content'] = '';

		try {
			$license_check = proxmox_vps_license_585();

			if ($license_check['status'] != 'Active') {
				$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
				throw new Exception($error_message);
			}

			$productController = new \MGProvision\ProxmoxVPS\controllers\admin\ProductController($_REQUEST);
			$data['content'] = $productController->indexHTML($_REQUEST);
		}
		catch (Exception $ex) {
			if (isset($_REQUEST['mode']) && $_REQUEST['mode'] == 'simple') {
				throw $ex;
			}

			$data['content'] .= '<div class="errorbox">' . $ex->getMessage() . '</span></div>';
		}

		if (isset($_REQUEST['mode']) && $_REQUEST['mode'] == 'simple') {
			ob_clean();
			header('Content-Type: application/json');
			echo json_encode($data);
			exit();
		}
		else {
			echo $data['content'];
		}

		return array();
	}
}

function proxmoxVPS_CreateAccount($params)
{
	$license_check = proxmox_vps_license_585();

	if ($license_check['status'] != 'Active') {
		$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
		return $error_message;
	}

	if (!empty($params['customfields']['vmid'])) {
		return 'Custom Field "VMID" is not empty';
	}

	if (!empty($params['customfields']['node'])) {
		return 'Custom Field "Node" is not empty';
	}

	return \MGProvision\ProxmoxVPS\Provision::accountAction('createAccount', $params);
}

function proxmoxVPS_ChangePackage($params)
{
	$license_check = proxmox_vps_license_585();

	if ($license_check['status'] != 'Active') {
		$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
		return $error_message;
	}

	if (empty($params['customfields']['vmid'])) {
		return 'Custom Field "VMID" is empty';
	}

	if (empty($params['customfields']['node'])) {
		return 'Custom Field "Node" is empty';
	}

	return \MGProvision\ProxmoxVPS\Provision::accountAction('changePackage', $params);
}

function proxmoxVPS_TerminateAccount($params)
{
	return \MGProvision\ProxmoxVPS\Provision::accountAction('terminateAccount', $params);
}

function proxmoxVPS_SuspendAccount($params)
{
	if (empty($params['customfields']['vmid'])) {
		return 'Custom Field "VMID" is empty';
	}

	if (empty($params['customfields']['node'])) {
		return 'Custom Field "Node" is empty';
	}

	return \MGProvision\ProxmoxVPS\Provision::accountAction('suspend', $params);
}

function proxmoxVPS_UnsuspendAccount($params)
{
	if (empty($params['customfields']['vmid'])) {
		return 'Custom Field "VMID" is empty';
	}

	if (empty($params['customfields']['node'])) {
		return 'Custom Field "Node" is empty';
	}

	return \MGProvision\ProxmoxVPS\Provision::accountAction('unsuspend', $params);
}

function proxmoxVPS_Reboot($params)
{
	if (empty($params['customfields']['vmid'])) {
		return 'Custom Field "VMID" is empty';
	}

	if (empty($params['customfields']['node'])) {
		return 'Custom Field "Node" is empty';
	}

	return \MGProvision\ProxmoxVPS\Provision::accountAction('reboot', $params);
}

function proxmoxVPS_Stop($params)
{
	if (empty($params['customfields']['vmid'])) {
		return 'Custom Field "VMID" is empty';
	}

	if (empty($params['customfields']['node'])) {
		return 'Custom Field "Node" is empty';
	}

	return \MGProvision\ProxmoxVPS\Provision::accountAction('stop', $params);
}

function proxmoxVPS_Shutdown($params)
{
	if (empty($params['customfields']['vmid'])) {
		return 'Custom Field "VMID" is empty';
	}

	if (empty($params['customfields']['node'])) {
		return 'Custom Field "Node" is empty';
	}

	return \MGProvision\ProxmoxVPS\Provision::accountAction('shutdown', $params);
}

function proxmoxVPS_Boot($params)
{
	if (empty($params['customfields']['vmid'])) {
		return 'Custom Field "VMID" is empty';
	}

	if (empty($params['customfields']['node'])) {
		return 'Custom Field "Node" is empty';
	}

	return \MGProvision\ProxmoxVPS\Provision::accountAction('start', $params);
}

function proxmoxVPS_AdminServicesTabFields($params)
{
	if (!empty($_REQUEST['json'])) {
		ob_clean();
		header('Content-Type: text/plain');
		$_REQUEST['page'] = 'ServiceFields';
		echo \MGProvision\ProxmoxVPS\Provision::I()->getJSONAdminPage($_REQUEST, $params);
		exit();
	}
	else {
		return \MGProvision\ProxmoxVPS\Provision::I()->servicesFields($_REQUEST, $params);
	}
}

function proxmoxVPS_ClientAreaCustomButtonArray($params)
{
	$_LANG = proxmoxVPS_getLang();
	$buttons[$_LANG['button.management']] = 'management';
	return $buttons;
}

function proxmoxVPS_ClientArea($params)
{
	if ($_GET['modop'] == 'custom' && $_GET['a'] == 'management') {
		return NULL;
	}

	try {
		if (isset($_REQUEST['page'])) {
			$_REQUEST['page'] = 'home';
		}

		$whmcs6 = isset($GLOBALS['CONFIG']['Version']) && '6.0.0' <= $GLOBALS['CONFIG']['Version'];
		if ($whmcs6 && \MGProvision\ProxmoxVPS\Provision::isTemplateSix()) {
			proxmoxVPS_ClientAreaPrimarySidebarHook($params);
		}

		return \MGProvision\ProxmoxVPS\Provision::clientarea($params);
	}
	catch (Exception $ex) {
		return array(
	'templatefile' => 'templates' . DS . 'clientarea' . DS . 'default' . DS . 'fatal',
	'breadcrumb'   => ' > <a href="#">Management</a>',
	'vars'         => array('message' => $ex->getMessage())
	);
	}
}

function proxmoxVPS_AdminLink($params)
{
	if ($_REQUEST['ajax'] == '1' && $_REQUEST['proxmoxvps_act'] == 'test_connection') {
		ob_clean();
		$res = array();

		try {
			$_REQUEST['serverpassword'] = html_entity_decode($_REQUEST['serverpassword']);
			$api = \MGProvision\Proxmox\v2\Api::whmcsFactory($_REQUEST);
			$api->debug();
			$res['success'] = '1';
			$res['result'] = 'Success';
		}
		catch (Exception $ex) {
			$res['result'] = $ex->getMessage();
		}

		echo json_encode($res);
		exit();
	}

	$id = uniqid();
	$scr = "\r\n        <script type=\"text/javascript\">\r\n        \r\n        \$(document).ready(function(){\r\n                \$(\".proxmoxVPS_connection" . $id . "\").click(function(){\r\n                        var \$a = \$(this);\r\n                        var \$div = \$(this).closest(\"div\");\r\n                        \$.post(window.location, {\"ajax\": \"1\", \"proxmoxvps_act\":\"test_connection\", \"serverip\":\$a.data(\"serverip\"), \"serverhostname\":\$a.data(\"serverhostname\"), \"serverusername\":\$a.data(\"serverusername\"), \"serverpassword\":\$a.data(\"serverpassword\"), \"serversecure\":\$a.data(\"serversecure\") , \"serveraccesshash\":\$a.data(\"serveraccesshash\")}, function(res){\r\n                                \$div.css(\"color\", res.success == \"1\" ? \"green\" : \"red\").html(res.result);\r\n                        }, \"json\");\r\n                        \$div.html(\"<img src=\\\"../modules/servers/proxmoxVPS/images/loader.gif\\\" />\");\r\n                        return false;\r\n                });\r\n        });\r\n        </script>\r\n        ";
	return $scr . '<div style="width:200px;"><a href="" class="proxmoxVPS_connection' . $id . '" data-serverip="' . $params['serverip'] . '" data-serverhostname="' . $params['serverhostname'] . '" data-serverusername="' . $params['serverusername'] . '" data-serverpassword="' . $params['serverpassword'] . '" data-serversecure="' . $params['serversecure'] . '" data-serveraccesshash="' . $params['serveraccesshash'] . '">Test Connection</a></div>';
}

function proxmoxVPS_UsageUpdate($params)
{
	return \MGProvision\ProxmoxVPS\Provision::accountAction('usageUpdate', $params);
}

function proxmoxVPS_TestConnection($params)
{
	try {
		$api = \MGProvision\Proxmox\v2\Api::whmcsFactory($params);
		$api->debug();
		return array('success' => true);
	}
	catch (Exception $e) {
		return array('error' => $e->getMessage());
	}
}

function proxmoxVPS_ChangeUser($params)
{
	if (empty($params['customfields']['vmid'])) {
		return 'Custom Field "VMID" is empty';
	}

	if (empty($params['customfields']['node'])) {
		return 'Custom Field "Node" is empty';
	}

	return \MGProvision\ProxmoxVPS\Provision::accountAction('changeUserRole', $params);
}

function proxmoxVPS_management($params)
{
	try {
		$product = new proxmoxVPS_Product($params['packageid']);
		$whmcs6 = isset($GLOBALS['CONFIG']['Version']) && '6.0.0' <= $GLOBALS['CONFIG']['Version'];
		$isSixTemplate = false;
		if ($whmcs6 && \MGProvision\ProxmoxVPS\Provision::isTemplateSix()) {
			$isSixTemplate = true;
			proxmoxVPS_ClientAreaPrimarySidebarHook($params);
		}
		else {
			$panel = \MGProvision\ProxmoxVPS\Provision::getSidebar('manageAccount', $params);
			$manageAccount = $panel['html'];
		}

		$out = \MGProvision\ProxmoxVPS\Provision::clientarea($params);
		$out['vars']['manageAccount'] = $manageAccount;
		$out['vars']['isTemplateSix'] = $isSixTemplate;
		return $out;
	}
	catch (Exception $ex) {
		return array(
	'templatefile' => 'templates' . DS . 'clientarea' . DS . 'default' . DS . 'fatal',
	'breadcrumb'   => ' > <a href="#">Management</a>',
	'vars'         => array('message' => $ex->getMessage())
	);
	}
}

function proxmoxVPS_ClientAreaPrimarySidebarHook($params)
{
	add_hook('ClientAreaPrimarySidebar', 1, function(\WHMCS\View\Menu\Item $primarySidebar) use($params) {
		$panel = $primarySidebar->getChild('Service Details Overview');

		if (is_a($panel, 'WHMCS\\View\\Menu\\Item')) {
			$panel = $panel->getChild('Information');

			if (is_a($panel, 'WHMCS\\View\\Menu\\Item')) {
				$panel->setUri('clientarea.php?action=productdetails&id=' . $params['serviceid']);
				$panel->setAttributes(array());
			}
		}

		$panel = \MGProvision\ProxmoxVPS\Provision::getSidebar('managevm', $params);

		if (is_null($panel)) {
			return NULL;
		}

		$sidebar = $primarySidebar->addChild($panel['id'], array('label' => $panel['label'], 'uri' => $panel['uri'], 'icon' => $panel['icon'], 'order' => 20));
		$sidebar->setBodyHtml($panel['html']);
		$panel = \MGProvision\ProxmoxVPS\Provision::getSidebar('additionalTools', $params);
		$sidebar = $primarySidebar->addChild($panel['id'], array('label' => $panel['label'], 'uri' => $panel['uri'], 'icon' => $panel['icon'], 'order' => 30));
		$sidebar->setBodyHtml($panel['html']);
	});
}

function proxmoxVPS_cron($params)
{
	try {
		error_reporting(1);
		ini_set('display_errors', '1');
		$cron = new ProxmoxVPSCron();
		$cron->updateDB();
		$cron->executeTasks();

		if ($ex = $cron->getLastException()) {
			echo '<pre>';
			print_r($ex);
			echo '</pre>';
			exit();
		}

		return 'success';
	}
	catch (Exception $ex) {
		return $ex->getMessage();
	}
}

if (!defined('DS')) {
	define('DS', DIRECTORY_SEPARATOR);
}

if (isset($_REQUEST['_debug']) && $_REQUEST['_debug'] == 'turnon') {
	$_SESSION['mg_proxmox_debug'] = 1;
}
else {
	if (isset($_REQUEST['_debug']) && $_REQUEST['_debug'] == 'turnoff') {
		$_SESSION['mg_proxmox_debug'] = NULL;
	}
}

if (!class_exists('MGProvision\\ProxmoxVPS\\Loader')) {
	require_once dirname(__FILE__) . DS . 'Loader.php';
	new \MGProvision\ProxmoxVPS\Loader();
}

include_once dirname(__FILE__) . DS . 'utility.php';
proxmoxVPS_load();

if (!function_exists('proxmoxVPS_AdminCustomButtonArray')) {
	function proxmoxVPS_AdminCustomButtonArray($params)
	{
		$buttonarray = array('Boot' => 'Boot', 'Reboot' => 'Reboot', 'Stop' => 'Stop', 'Shutdown' => 'Shutdown', 'Change User Role' => 'ChangeUser');
		$product = new proxmoxVps_Product($params['pid']);

		if ($product->getConfig('debug_mode') == 'Yes') {
			$buttonarray['Debug'] = 'cron';
		}

		return $buttonarray;
	}
}

if ($_REQUEST['id']) {
	try {
		$kvm_sshResetPassword = (bool) \MGProvision\ProxmoxVPS\libs\PdoWrapper::numRows(\MGProvision\ProxmoxVPS\libs\PdoWrapper::query("SELECT p.`value`\r\n                                                              FROM `proxmoxVPS_prodConfig` p\r\n                                                              LEFT JOIN tblhosting h ON ( h.packageid = p.product_id )\r\n                                                              WHERE h.id =?\r\n                                                              AND p.`setting` = ?\r\n                                                              AND p.`value` = ? ", array($_REQUEST['id'], 'kvm_sshResetPassword', '1')));
	}
	catch (Exception $ex) {
	}
}

if ($kvm_sshResetPassword) {
	function proxmoxVPS_ChangePassword($params)
	{
		if (empty($params['customfields']['vmid'])) {
			return 'Custom Field "VMID" is empty';
		}

		if (empty($params['customfields']['node'])) {
			return 'Custom Field "Node" is empty';
		}

		try {
			$cron = new \MGProvision\ProxmoxVPS\controllers\admin\CronController($params);
			$cron->resetPasswordProcess();
			return 'success';
		}
		catch (Exception $e) {
			return 'ERROR: ' . $e->getMessage();
		}
	}
}

?>
