<?php
//dezend by http://www.yunlu99.com/
class proxmox_vps_license_4630PDOWrapper
{
	static private $pdoConnection;

	static private function getDbConnection()
	{
		if (class_exists('Illuminate\\Database\\Capsule\\Manager')) {
			return \Illuminate\Database\Capsule\Manager::connection()->getPdo();
		}

		if (self::$pdoConnection === NULL) {
			self::$pdoConnection = self::setNewConnection();
		}

		return self::$pdoConnection;
	}

	static private function setNewConnection()
	{
		try {
			$includePath = ROOTDIR . DIRECTORY_SEPARATOR . 'configuration.php';

			if (file_exists($includePath)) {
				require $includePath;
			}
			else {
				throw new Exception('No configuration file found');
			}

			$connection = new PDO(sprintf('mysql:host=%s;dbname=%s;port=%s;charset=utf8', $db_host, $db_name, $db_port ? $db_port : 3360), $db_username, $db_password);
			$connection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			return $connection;
		}
		catch (PDOException $exc) {
		}
	}

	static public function query($query, $params = array())
	{
		$statement = self::getDbConnection()->prepare($query);
		$statement->execute($params);
		return $statement;
	}

	static public function real_escape_string($string)
	{
		return substr(self::getDbConnection()->quote($string), 1, -1);
	}

	static public function fetch_assoc($query)
	{
		return $query->fetch(PDO::FETCH_ASSOC);
	}

	static public function fetch_array($query)
	{
		return $query->fetch(PDO::FETCH_BOTH);
	}

	static public function fetch_object($query)
	{
		return $query->fetch(PDO::FETCH_OBJ);
	}

	static public function num_rows($query)
	{
		$query->fetch(PDO::FETCH_BOTH);
		return $query->rowCount();
	}

	static public function insert_id()
	{
		return self::getDbConnection()->lastInsertId();
	}

	static public function errorInfo()
	{
		$tmpErr = self::getDbConnection()->errorInfo();
		if ($tmpErr[0] && $tmpErr[0] !== '00000') {
			return $tmpErr;
		}

		return false;
	}

	static public function mysql_get_array($query, $params = array())
	{
		$qRes = self::query($query, $params);
		$arr = array();

		while ($row = self::fetch_assoc($qRes)) {
			$arr[] = $row;
		}

		return $arr;
	}

	static public function mysql_get_row($query, $params = array())
	{
		$qRes = self::query($query, $params);
		return self::fetch_assoc($qRes);
	}
}

function proxmox_vps_license_4630()
{
	return array('status' => 'Active', 'description' => 'Crack by SakuraMC');
}

function proxmoxVPS_ConfigOptions($prameters = array())
{
	proxmoxVPS_debug();
	if (isset($_REQUEST['action']) && $_REQUEST['action'] != 'save' && preg_match('/configproducts.php/', $_SERVER['SCRIPT_FILENAME'])) {
		$data = array();
		$data['mode'] = 'advanced';
		$data['content'] = '';

		try {
			$license_check = proxmox_vps_license_4630();

			if ($license_check['status'] != 'Active') {
				$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
				throw new Exception($error_message);
			}

			$productController = new \MGProvision\ProxmoxVPS\controllers\admin\ProductController($_REQUEST);
			$data['content'] = $productController->indexHTML($_REQUEST);
		}
		catch (Exception $ex) {
			if (isset($_REQUEST['mode']) && $_REQUEST['mode'] == 'simple') {
				throw $ex;
			}

			$data['content'] .= '<div class="errorbox">' . $ex->getMessage() . '</span></div>';
		}

		if (isset($_REQUEST['mode']) && $_REQUEST['mode'] == 'simple') {
			\MGProvision\ProxmoxVPS\mgLibs\Utility::obClean();
			header('Content-Type: application/json');
			echo json_encode($data);
			exit();
		}
		else {
			echo $data['content'];
		}

		return array();
	}
}

function proxmoxVPS_CreateAccount($params)
{
	$license_check = proxmox_vps_license_4630();

	if ($license_check['status'] != 'Active') {
		$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
		return $error_message;
	}

	if (!empty($params['customfields']['vmid'])) {
		return 'Custom Field "VMID" is not empty';
	}

	if (!empty($params['customfields']['node'])) {
		return 'Custom Field "Node" is not empty';
	}

	return \MGProvision\ProxmoxVPS\Provision::accountAction('createAccount', $params);
}

function proxmoxVPS_ChangePackage($params)
{
	$license_check = proxmox_vps_license_4630();

	if ($license_check['status'] != 'Active') {
		$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
		return $error_message;
	}

	if (empty($params['customfields']['vmid'])) {
		return 'Custom Field "VMID" is empty';
	}

	if (empty($params['customfields']['node'])) {
		return 'Custom Field "Node" is empty';
	}

	return \MGProvision\ProxmoxVPS\Provision::accountAction('changePackage', $params);
}

function proxmoxVPS_TerminateAccount($params)
{
	return \MGProvision\ProxmoxVPS\Provision::accountAction('terminateAccount', $params);
}

function proxmoxVPS_SuspendAccount($params)
{
	if (empty($params['customfields']['vmid'])) {
		return 'Custom Field "VMID" is empty';
	}

	if (empty($params['customfields']['node'])) {
		return 'Custom Field "Node" is empty';
	}

	return \MGProvision\ProxmoxVPS\Provision::accountAction('suspend', $params);
}

function proxmoxVPS_UnsuspendAccount($params)
{
	if (empty($params['customfields']['vmid'])) {
		return 'Custom Field "VMID" is empty';
	}

	if (empty($params['customfields']['node'])) {
		return 'Custom Field "Node" is empty';
	}

	return \MGProvision\ProxmoxVPS\Provision::accountAction('unsuspend', $params);
}

function proxmoxVPS_Reboot($params)
{
	if (empty($params['customfields']['vmid'])) {
		return 'Custom Field "VMID" is empty';
	}

	if (empty($params['customfields']['node'])) {
		return 'Custom Field "Node" is empty';
	}

	return \MGProvision\ProxmoxVPS\Provision::accountAction('reboot', $params);
}

function proxmoxVPS_Stop($params)
{
	if (empty($params['customfields']['vmid'])) {
		return 'Custom Field "VMID" is empty';
	}

	if (empty($params['customfields']['node'])) {
		return 'Custom Field "Node" is empty';
	}

	return \MGProvision\ProxmoxVPS\Provision::accountAction('stop', $params);
}

function proxmoxVPS_Shutdown($params)
{
	if (empty($params['customfields']['vmid'])) {
		return 'Custom Field "VMID" is empty';
	}

	if (empty($params['customfields']['node'])) {
		return 'Custom Field "Node" is empty';
	}

	return \MGProvision\ProxmoxVPS\Provision::accountAction('shutdown', $params);
}

function proxmoxVPS_Boot($params)
{
	if (empty($params['customfields']['vmid'])) {
		return 'Custom Field "VMID" is empty';
	}

	if (empty($params['customfields']['node'])) {
		return 'Custom Field "Node" is empty';
	}

	return \MGProvision\ProxmoxVPS\Provision::accountAction('start', $params);
}

function proxmoxVPS_AdminServicesTabFields($params)
{
	if (!empty($_REQUEST['json'])) {
		\MGProvision\ProxmoxVPS\mgLibs\Utility::obClean();
		header('Content-Type: text/plain');
		$_REQUEST['page'] = 'ServiceFields';
		echo \MGProvision\ProxmoxVPS\Provision::I()->getJSONAdminPage($_REQUEST, $params);
		exit();
	}
	else {
		return \MGProvision\ProxmoxVPS\Provision::I()->servicesFields($_REQUEST, $params);
	}
}

function proxmoxVPS_ClientAreaCustomButtonArray($params)
{
	$_LANG = proxmoxVPS_getLang();
	$buttons[$_LANG['button.management']] = 'management';
	return $buttons;
}

function proxmoxVPS_ClientArea($params)
{
	if ($_GET['modop'] == 'custom' && $_GET['a'] == 'management') {
		return NULL;
	}

	try {
		if (isset($_REQUEST['page'])) {
			$_REQUEST['page'] = 'home';
		}

		$whmcs6 = isset($GLOBALS['CONFIG']['Version']) && '6.0.0' <= $GLOBALS['CONFIG']['Version'];
		if ($whmcs6 && \MGProvision\ProxmoxVPS\Provision::isTemplateSix()) {
			proxmoxVPS_ClientAreaPrimarySidebarHook($params);
		}

		return \MGProvision\ProxmoxVPS\Provision::clientarea($params);
	}
	catch (Exception $ex) {
		return array(
	'templatefile' => 'templates' . DS . 'clientarea' . DS . 'default' . DS . 'fatal',
	'breadcrumb'   => ' > <a href="#">Management</a>',
	'vars'         => array('message' => $ex->getMessage())
	);
	}
}

function proxmoxVPS_AdminLink($params)
{
	if ($_REQUEST['ajax'] == '1' && $_REQUEST['proxmoxvps_act'] == 'test_connection') {
		\MGProvision\ProxmoxVPS\mgLibs\Utility::obClean();
		$res = array();

		try {
			$_REQUEST['serverpassword'] = html_entity_decode($_REQUEST['serverpassword']);
			$api = \MGProvision\Proxmox\v2\Api::whmcsFactory($_REQUEST);
			$api->debug();
			$res['success'] = '1';
			$res['result'] = 'Success';
		}
		catch (Exception $ex) {
			$res['result'] = $ex->getMessage();
		}

		echo json_encode($res);
		exit();
	}

	$id = uniqid();
	$scr = "\r\n        <script type=\"text/javascript\">\r\n        \r\n        \$(document).ready(function(){\r\n                \$(\".proxmoxVPS_connection" . $id . "\").click(function(){\r\n                        var \$a = \$(this);\r\n                        var \$div = \$(this).closest(\"div\");\r\n                        \$.post(window.location, {\"ajax\": \"1\", \"proxmoxvps_act\":\"test_connection\", \"serverip\":\$a.data(\"serverip\"), \"serverhostname\":\$a.data(\"serverhostname\"), \"serverusername\":\$a.data(\"serverusername\"), \"serverpassword\":\$a.data(\"serverpassword\"), \"serversecure\":\$a.data(\"serversecure\") , \"serveraccesshash\":\$a.data(\"serveraccesshash\")}, function(res){\r\n                                \$div.css(\"color\", res.success == \"1\" ? \"green\" : \"red\").html(res.result);\r\n                        }, \"json\");\r\n                        \$div.html(\"<img src=\\\"../modules/servers/proxmoxVPS/images/loader.gif\\\" />\");\r\n                        return false;\r\n                });\r\n        });\r\n        </script>\r\n        ";
	return $scr . '<div style="width:200px;"><a href="" class="proxmoxVPS_connection' . $id . '" data-serverip="' . $params['serverip'] . '" data-serverhostname="' . $params['serverhostname'] . '" data-serverusername="' . $params['serverusername'] . '" data-serverpassword="' . $params['serverpassword'] . '" data-serversecure="' . $params['serversecure'] . '" data-serveraccesshash="' . $params['serveraccesshash'] . '">Test Connection</a></div>';
}

function proxmoxVPS_UsageUpdate($params)
{
	return \MGProvision\ProxmoxVPS\Provision::accountAction('usageUpdate', $params);
}

function proxmoxVPS_TestConnection($params)
{
	try {
		if (!$params['serverip'] && !$params['serverhostname']) {
			throw new Exception('Server Hostname or  IP Address  is empty.');
		}

		if ($params['serverip']) {
			$api = new \MGProvision\Proxmox\v2\Api($params['serverip'], $params['serverusername'], $params['serveraccesshash'], $params['serverpassword']);
			$api->debug();
		}

		if ($params['serverhostname']) {
			if (preg_match('/[\\/]/', $params['serverhostname'])) {
				throw new Exception(sprintf('Server Hostname \'%s\' is invalid', $params['serverhostname']));
			}

			$api = new \MGProvision\Proxmox\v2\Api($params['serverhostname'], $params['serverusername'], $params['serveraccesshash'], $params['serverpassword']);
			$api->debug();
		}

		return array('success' => true);
	}
	catch (Exception $e) {
		return array('error' => $e->getMessage());
	}
}

function proxmoxVPS_ChangeUser($params)
{
	if (empty($params['customfields']['vmid'])) {
		return 'Custom Field "VMID" is empty';
	}

	if (empty($params['customfields']['node'])) {
		return 'Custom Field "Node" is empty';
	}

	return \MGProvision\ProxmoxVPS\Provision::accountAction('changeUserRole', $params);
}

function proxmoxVPS_management($params)
{
	try {
		$product = new proxmoxVPS_Product($params['packageid']);
		$whmcs6 = isset($GLOBALS['CONFIG']['Version']) && '6.0.0' <= $GLOBALS['CONFIG']['Version'];
		$isSixTemplate = false;
		if ($whmcs6 && \MGProvision\ProxmoxVPS\Provision::isTemplateSix()) {
			$isSixTemplate = true;
			proxmoxVPS_ClientAreaPrimarySidebarHook($params);
		}
		else {
			$panel = \MGProvision\ProxmoxVPS\Provision::getSidebar('manageAccount', $params);
			$manageAccount = $panel['html'];
		}

		$out = \MGProvision\ProxmoxVPS\Provision::clientarea($params);
		$out['vars']['manageAccount'] = $manageAccount;
		$out['vars']['isTemplateSix'] = $isSixTemplate;
		return $out;
	}
	catch (Exception $ex) {
		return array(
	'templatefile' => 'templates' . DS . 'clientarea' . DS . 'default' . DS . 'fatal',
	'breadcrumb'   => ' > <a href="#">Management</a>',
	'vars'         => array('message' => $ex->getMessage())
	);
	}
}

function proxmoxVPS_ClientAreaPrimarySidebarHook($params)
{
	add_hook('ClientAreaPrimarySidebar', 1, function(\WHMCS\View\Menu\Item $primarySidebar) use($params) {
		$panel = $primarySidebar->getChild('Service Details Overview');

		if (is_a($panel, 'WHMCS\\View\\Menu\\Item')) {
			$panel = $panel->getChild('Information');

			if (is_a($panel, 'WHMCS\\View\\Menu\\Item')) {
				$panel->setUri('clientarea.php?action=productdetails&id=' . $params['serviceid']);
				$panel->setAttributes(array());
			}
		}

		$panel = $primarySidebar->getChild('Service Details Actions');
		if (isset($_GET['a']) && is_a($panel, 'WHMCS\\View\\Menu\\Item')) {
			$panel = $panel->getChild('Change Password');

			if (is_a($panel, 'WHMCS\\View\\Menu\\Item')) {
				$panel->setUri('clientarea.php?action=productdetails&id=' . $params['serviceid'] . '#tabChangepw');
				$panel->setAttributes(array());
			}
		}

		$panel = \MGProvision\ProxmoxVPS\Provision::getSidebar('managevm', $params);

		if (is_null($panel)) {
			return NULL;
		}

		$sidebar = $primarySidebar->addChild($panel['id'], array('label' => $panel['label'], 'uri' => $panel['uri'], 'icon' => $panel['icon'], 'order' => 20));
		$sidebar->setBodyHtml($panel['html']);
		$panel = \MGProvision\ProxmoxVPS\Provision::getSidebar('additionalTools', $params);
		$sidebar = $primarySidebar->addChild($panel['id'], array('label' => $panel['label'], 'uri' => $panel['uri'], 'icon' => $panel['icon'], 'order' => 30));
		$sidebar->setBodyHtml($panel['html']);
	});
}

function proxmoxVPS_cron($params)
{
	try {
		error_reporting(1);
		ini_set('display_errors', '1');
		$cron = new ProxmoxVPSCron();
		$cron->updateDB();
		$cron->setMaxAttempt(1001);
		$cron->executeTasks();

		if ($ex = $cron->getLastException()) {
			echo '<pre>';
			print_r($ex);
			echo '</pre>';
			exit();
		}

		return 'success';
	}
	catch (Exception $ex) {
		return $ex->getMessage();
	}
}

if (!defined('DS')) {
	define('DS', DIRECTORY_SEPARATOR);
}

if (isset($_REQUEST['_debug']) && $_REQUEST['_debug'] == 'turnon') {
	$_SESSION['mg_proxmox_debug'] = 1;
}
else {
	if (isset($_REQUEST['_debug']) && $_REQUEST['_debug'] == 'turnoff') {
		$_SESSION['mg_proxmox_debug'] = NULL;
	}
}

if (!class_exists('MGProvision\\ProxmoxVPS\\Loader')) {
	require_once dirname(__FILE__) . DS . 'Loader.php';
	new \MGProvision\ProxmoxVPS\Loader();
}

include_once dirname(__FILE__) . DS . 'utility.php';
proxmoxVPS_load();

if (!function_exists('proxmoxVPS_AdminCustomButtonArray')) {
	function proxmoxVPS_AdminCustomButtonArray($params)
	{
		$buttonarray = array('Boot' => 'Boot', 'Reboot' => 'Reboot', 'Stop' => 'Stop', 'Shutdown' => 'Shutdown', 'Change User Role' => 'ChangeUser');
		$product = new proxmoxVps_Product($params['pid']);

		if ($product->getConfig('debug_mode') == 'Yes') {
			$buttonarray['Debug'] = 'cron';
		}

		return $buttonarray;
	}
}

if ($_REQUEST['id']) {
	try {
		$kvm_sshResetPassword = (bool) \MGProvision\ProxmoxVPS\libs\PdoWrapper::numRows(\MGProvision\ProxmoxVPS\libs\PdoWrapper::query("SELECT p.`value`\r\n                                                              FROM `proxmoxVPS_prodConfig` p\r\n                                                              LEFT JOIN tblhosting h ON ( h.packageid = p.product_id )\r\n                                                              WHERE h.id =?\r\n                                                              AND p.`setting` = ?\r\n                                                              AND p.`value` = ? ", array($_REQUEST['id'], 'kvm_sshResetPassword', '1')));
	}
	catch (Exception $ex) {
	}
}

if ($kvm_sshResetPassword) {
	function proxmoxVPS_ChangePassword($params)
	{
		if (empty($params['customfields']['vmid'])) {
			return 'Custom Field "VMID" is empty';
		}

		if (empty($params['customfields']['node'])) {
			return 'Custom Field "Node" is empty';
		}

		try {
			$cron = new \MGProvision\ProxmoxVPS\controllers\admin\CronController($params);
			$cron->resetPasswordProcess();
			return 'success';
		}
		catch (Exception $e) {
			return 'ERROR: ' . $e->getMessage();
		}
	}
}

?>
