<?php
//dezend by http://www.yunlu99.com/
class solusvm_extended_cloud_license_4487PDOWrapper
{
	static private $pdoConnection;

	static private function getDbConnection()
	{
		if (class_exists('Illuminate\\Database\\Capsule\\Manager')) {
			return \Illuminate\Database\Capsule\Manager::connection()->getPdo();
		}

		if (self::$pdoConnection === NULL) {
			self::$pdoConnection = self::setNewConnection();
		}

		return self::$pdoConnection;
	}

	static private function setNewConnection()
	{
		try {
			$includePath = ROOTDIR . DIRECTORY_SEPARATOR . 'configuration.php';

			if (file_exists($includePath)) {
				require $includePath;
			}
			else {
				throw new Exception('No configuration file found');
			}

			$connection = new PDO(sprintf('mysql:host=%s;dbname=%s;port=%s;charset=utf8', $db_host, $db_name, $db_port ? $db_port : 3360), $db_username, $db_password);
			$connection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			return $connection;
		}
		catch (PDOException $exc) {
		}
	}

	static public function query($query, $params = array())
	{
		$statement = self::getDbConnection()->prepare($query);
		$statement->execute($params);
		return $statement;
	}

	static public function real_escape_string($string)
	{
		return substr(self::getDbConnection()->quote($string), 1, -1);
	}

	static public function fetch_assoc($query)
	{
		return $query->fetch(PDO::FETCH_ASSOC);
	}

	static public function fetch_array($query)
	{
		return $query->fetch(PDO::FETCH_BOTH);
	}

	static public function fetch_object($query)
	{
		return $query->fetch(PDO::FETCH_OBJ);
	}

	static public function num_rows($query)
	{
		$query->fetch(PDO::FETCH_BOTH);
		return $query->rowCount();
	}

	static public function insert_id()
	{
		return self::getDbConnection()->lastInsertId();
	}

	static public function errorInfo()
	{
		$tmpErr = self::getDbConnection()->errorInfo();
		if ($tmpErr[0] && $tmpErr[0] !== '00000') {
			return $tmpErr;
		}

		return false;
	}

	static public function mysql_get_array($query, $params = array())
	{
		$qRes = self::query($query, $params);
		$arr = array();

		while ($row = self::fetch_assoc($qRes)) {
			$arr[] = $row;
		}

		return $arr;
	}

	static public function mysql_get_row($query, $params = array())
	{
		$qRes = self::query($query, $params);
		return self::fetch_assoc($qRes);
	}
}

function solusvm_extended_cloud_license_4487()
{
	return array('status' => 'Active', 'description' => '模块破解By TrollCraft & Akkariin Meiko.');	
}
function solusvmExtendedCloud_ConfigOptions($prameters = array())
{
	$ex = explode(DS, $_SERVER['SCRIPT_FILENAME']);
	if ($_REQUEST['action'] != 'save' && end($ex) == 'configproducts.php') {
		$data = array();
		$data['mode'] = 'advanced';
		$data['content'] = '';

		try {
			$license_check = solusvm_extended_cloud_license_4487();

			if ($license_check['status'] != 'Active') {
				$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
				throw new Exception($error_message);
			}

			\MGModule\solusvmExtendedCloud\mgLibs\MySQL\PdoWrapper::query("\n                                CREATE TABLE IF NOT EXISTS `solusvmextendedcloud_vservers` (\n                                `id` int(10) unsigned NOT NULL AUTO_INCREMENT,\n                                `hosting_id` int(10) unsigned NOT NULL,\n                                `hostname` varchar(100) NOT NULL,\n                                `vserverid` int(10) unsigned NOT NULL,\n                                `rootpassword` varchar(100) NOT NULL,\n                                `nodeid` varchar(100) NOT NULL,\n                                `internalip` varchar(100) DEFAULT NULL,\n                                `memory` int(10) unsigned NOT NULL,\n                                `cpu_cores` int(10) unsigned NOT NULL,\n                                `disk_space` int(10) unsigned NOT NULL,\n                                `bandwidth` int(10) unsigned NOT NULL,\n                                `ips` int(10) unsigned NOT NULL,\n                                PRIMARY KEY (`id`)\n                                ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;\n                        ");
			\MGModule\solusvmExtendedCloud\mgLibs\MySQL\PdoWrapper::query("CREATE TABLE IF NOT EXISTS `solusvmextendedcloud_licenses` (\n                            `id`  int(11) NOT NULL AUTO_INCREMENT,\n                            `hosting_id` int(10) NOT NULL,\n                            `vserver_id` int(10) unsigned,\n                            `monthly` TINYINT(1) DEFAULT 0,\n                            `yearly` TINYINT(1)  DEFAULT 0,\n                            `date` DATETIME,\n                            PRIMARY KEY (`id`),\n                            FOREIGN KEY (vserver_id)\n                            REFERENCES solusvmextendedcloud_vservers(id) ON DELETE CASCADE\n                            ) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
			$product = new solusvmExtended_ProductCloud($_REQUEST['id']);
			$params = $product->getParams('solusvmExtendedCloud');
			$configOption1 = trim($params['configoption1']);
			if (!$product->getConfig('cloud_virtualization_type') && empty($configOption1)) {
				foreach ($product->firstConfig as $k => $v) {
					$product->saveConfig($k, $v);
				}
			}

			if (!$product->getConfig('cloud_virtualization_type') && !empty($configOption1)) {
				$product->moveOldCOnfig($params);
			}

			if (empty($params)) {
				throw new Exception('Please set up solusvmExtendedCloud server first');
			}

			$type = $product->getConfig('cloud_virtualization_type');

			if (empty($type)) {
				$type = 'openvz';
			}

			$params['serverpassword'] = decrypt($params['serverpassword']);
			$API = new SolusVMConnectionCloud(solusvmExtendedCloud_getHostname($params), $params['serverusername'], $params['serverpassword']);
			$API->timeout = 6;
			$API->setDebugMode($product->getConfig('so_debug'));
			$res_nodes = $API->call('listnodes', array('type' => $type));
			if ($res_nodes && isset($res_nodes['status']) && $res_nodes['status'] == 'success') {
				$nodes = explode(',', $res_nodes['nodes']);
			}

			$nodeGroups = $API->call('listnodegroups', array('type' => $type));
			if ($nodeGroups && isset($nodeGroups['status']) && $nodeGroups['status'] == 'success') {
				$nodeGroups['nodegroups'] = explode(',', $nodeGroups['nodegroups']);

				if (preg_match('/--none--/', $nodeGroups['nodegroups'][0])) {
					unset($nodeGroups['nodegroups'][0]);
				}

				foreach ($nodeGroups['nodegroups'] as $opt) {
					list($k, $n) = explode('|', $opt);
					$product->defaultConfig['nodeGroups']['options'][$k] = $n;
				}
			}

			$product->defaultConfig['cloud_default_node']['options'] = $nodes;
			$res_plans = $API->call('listplans', array('type' => $type));
			if ($res_plans && isset($res_plans['status']) && $res_plans['status'] == 'success') {
				$plans = explode(',', $res_plans['plans']);
			}

			$product->defaultConfig['cloud_plan']['options'] = $plans;
			$template_list = $API->getTemplates($type, true);

			if ($template_list) {
				$product->defaultConfig['templates']['options'] = $template_list;
			}

			$iso_list = $API->getIsos($type, true);

			if ($iso_list) {
				$product->defaultConfig['iso_images']['options'] = $iso_list;
			}

			$js = "\n\t\t\t\t<script type=\"text/javascript\">\n\t\t\t\t\$(document).ready(function(){\n\t\t\t\t\t\$(\"#solus_configurable_options\").click(function(){\n\t\t\t\t\t\t\$.post(\"../clientarea.php?sylusvmcloud_ajax=1\", {\"sylusvm_act\":\"sylusvm_setup_configurable_options\", \"productid\":" . $_REQUEST['id'] . "}, function(res){\n\t\t\t\t\t\t\talert(res.result);\n                                                 if(res.success==1)\n      \t\t\t\t\t\t\tif(\$(\"#tabLink5\").size())\n                                                              window.location.href = \"configproducts.php?action=edit&id=" . $_REQUEST['id'] . "&tab=5\";\n                                                          else\n                                                              window.location.href = \"configproducts.php?action=edit&id=" . $_REQUEST['id'] . "&tab=4\";\n\t\t\t\t\t\t}, \"json\");\n\t\t\t\t\t\treturn false;\n\t\t\t\t\t});\n\t\t\t\t\t\n\t\t\t\t\t\$(\".so_popup\").click(function(){\n\t\t\t\t\t\twindow.open(\"../modules/servers/solusvmExtendedCloud/templates/\" + \$(this).attr(\"rel\"), \"\",\"width=750,height=350,scrollbars=yes\");\n\t\t\t\t\t\treturn false;\n\t\t\t\t\t});\n                                   //Copy Setup From\n                                   \$(\"select[name='customconfigoption[productTarget]']\").change(function() {\n                                      if(confirm(\"Are you sure to copy setup from selected product?\")){\n                                          \$(\"form[name=packagefrm]\").submit();\n                                      }\n                                  });\n                                  //reload\n                                   \$(\"select[name='customconfigoption[cloud_virtualization_type]']\").change(function() {\n                                            if(confirm(\"Choosing this option causes reload the configuration.\")){\n                                                \$(\"form[name=packagefrm]\").submit();\n                                            }\n                                   });\n\t\t\t\t});\n\t\t\t\t</script>\n\t\t\t";
			$productsForCopy = $product->getProductsForCopy();
			$product->defaultConfig['productTarget']['options'] += $productsForCopy;

			if (empty($productsForCopy)) {
				unset($product->defaultConfig['productTarget']);
			}

			$product->defaultConfig['nodesFriendlyNames'] = 'Nodes Friendly Name';

			foreach ($nodes as $node) {
				$product->defaultConfig['nfn_' . $node] = array('title' => $node, 'type' => 'text', 'default' => $node, 'description' => '');
			}

			$product->defaultConfig['nspeed']['options'] = $product->getNetworkSpeedOptions();
			$data['content'] .= $product->renderConfigOptions($js);
		}
		catch (Exception $ex) {
			$data['content'] .= '<div class="errorbox">' . $ex->getMessage() . '</span></div>';
		}

		if (isset($_REQUEST['mode']) && $_REQUEST['mode'] == 'simple') {
			ob_clean();
			header('Content-Type: application/json');
			echo json_encode($data);
			exit();
		}
		else {
			echo $data['content'];
		}

		return array();
	}
}

function solusvmExtendedCloud_CreateAccount($params)
{
	solusvmExtended_debug();
	$license_check = solusvm_extended_cloud_license_4487();

	if ($license_check['status'] != 'Active') {
		$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
		echo '<strong>License Error: ' . $error_message . '</strong>';
		return $error_message;
	}

	$API = new SolusVMConnectionCloud(solusvmExtendedCloud_getHostname($params), $params['serverusername'], $params['serverpassword']);
	$API->timeout = 15;
	$_LANG = solusvmExtended_getLangCloud();
	$API->setTranslate($_LANG);
	$product = new solusvmExtended_ProductCloud(NULL, $params['serviceid']);
	$hosting = new solusvmExtended_HostingCloud($params['serviceid']);
	$hosting->load();
	$API->setDebugMode($product->getConfig('so_debug'));
	$username_prefix = $product->getConfig('cloud_username_prefix');
	var_dump();
	if ($username_prefix && !preg_match('/^' . $username_prefix . '/', $params['username'])) {
		$params['username'] = $username_prefix . $params['username'];
	}

	$user = array('username' => $params['username'], 'password' => $params['password'], 'email' => $params['clientsdetails']['email'], 'firstname' => $params['clientsdetails']['firstname'], 'lastname' => $params['clientsdetails']['lastname'], 'company' => $params['clientsdetails']['companyname']);
	$i = 1;

	do {
		$call_client_create = $API->call('client-create', $user);
		if ($call_client_create['status'] == 'success' || $hosting->domainstatus == 'Active') {
			break;
		}

		$user['username'] = $params['username'] . $i;
		++$i;
	} while ($i <= 10);

	if ($call_client_create && isset($call_client_create['status']) && $call_client_create['status'] == 'success') {
		$hosting->update(array('username' => $user['username']));
		return 'success';
	}

	return isset($call_client_create['statusmsg']) ? $call_client_create['statusmsg'] : (isset($API->error) && $API->error ? 'cURL error: ' . $API->error : 'Error during client creation.');
}

function solusvmExtendedCloud_TerminateAccount($params)
{
	solusvmExtended_debug();
	$API = new SolusVMConnectionCloud(solusvmExtendedCloud_getHostname($params), $params['serverusername'], $params['serverpassword']);
	$_LANG = solusvmExtended_getLangCloud();
	$API->setTranslate($_LANG);
	$product = new solusvmExtended_ProductCloud(NULL, $params['serviceid']);
	$API->setDebugMode($product->getConfig('so_debug'));
	$removed_ips = array();
	$cloud = new solusvmExtendedCloud_Cloud($params['serviceid']);
	$vservers = $cloud->getVservers();

	foreach ($vservers as $vserver) {
		if ($vserver->vserverid) {
			$call = $API->call('vserver-terminate', array('vserverid' => $vserver->vserverid, 'deleteclient' => 'false'));
			$removed_ips[] = $vserver->vserverid;
			$vserver->remove();
		}
	}

	$call = $API->call('client-delete', array('username' => $params['username']));
	if ($call && isset($call['status']) && $call['status'] == 'success') {
		return 'success';
	}

	if ($call) {
		$str = !empty($removed_ips) ? 'Removed vservers:' . implode(', ', $removed_ips) . '. ' : '';
		return $str . 'Error: ' . $call['statusmsg'];
	}

	return 'Unknown error. Please, check server details.';
}

function solusvmExtendedCloud_SuspendAccount($params)
{
	$cloud = new solusvmExtendedCloud_Cloud($params['serviceid']);

	try {
		$vservers = $cloud->getVservers();

		if (empty($vservers)) {
			return 'success';
		}

		foreach ($vservers as $vserver) {
			if ($vserver->vserverid) {
				$solusvmExtendedCloud = new SolusVMCloud($vserver->vserverid);
				$result = $solusvmExtendedCloud->suspend($params);
			}
		}

		return $result;
	}
	catch (Exception $e) {
		return $e->getMessage();
	}
}

function solusvmExtendedCloud_UnsuspendAccount($params)
{
	$cloud = new solusvmExtendedCloud_Cloud($params['serviceid']);

	try {
		$vservers = $cloud->getVservers();

		if (empty($vservers)) {
			return 'success';
		}

		foreach ($vservers as $vserver) {
			if ($vserver->vserverid) {
				$solusvmExtendedCloud = new SolusVMCloud($vserver->vserverid);
				$result = $solusvmExtendedCloud->unsuspend($params);
			}
		}

		return $result;
	}
	catch (Exception $e) {
		return $e->getMessage();
	}
}

function solusvmExtendedCloud_AdminServicesTabFields($params)
{
	$license_check = solusvm_extended_cloud_license_4487();

	if ($license_check['status'] != 'Active') {
		$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
		return array('License' => '<span class="label terminated">' . $error_message . '</span>');
	}

	if (!empty($_REQUEST['json'])) {
		if (ob_get_contents()) {
			ob_clean();
		}

		header('Content-Type: text/plain');
		$_REQUEST['mg-page'] = 'ServiceFields';
		echo \MGModule\solusvmExtendedCloud\server::getJsonAdminPage($_REQUEST, $params);
		exit();
	}

	return \MGModule\solusvmExtendedCloud\server::I()->servicesFields($_REQUEST, $params);
}

function solusvmExtendedCloud_ClientArea($params)
{
	if ($_GET['modop'] == 'custom' && $_GET['a'] == 'management') {
		return NULL;
	}

	if (!empty($_REQUEST['json'])) {
		ob_clean();
		echo \MGModule\solusvmExtendedCloud\server::getJSONClientAreaPage($params, $_REQUEST);
		exit();
	}
	else {
		return \MGModule\solusvmExtendedCloud\server::getHTMLClientAreaPage($params, $_REQUEST);
	}

	global $smarty;
	solusvmExtended_debug();
	$_LANG = solusvmExtended_getLangCloud();
	$cloud = new solusvmExtendedCloud_Cloud($params['serviceid']);
	$vservers = $cloud->getVservers();
	$API = new SolusVMConnectionCloud(solusvmExtendedCloud_getHostname($params), $params['serverusername'], $params['serverpassword']);
	$API->setTranslate($_LANG);
	$product = new solusvmExtended_ProductCloud(NULL, $params['serviceid']);
	$vars = array('_LANG' => $_LANG, 'isDNSManagerInstalled' => solusvmExtendedCloud_isDNSManagerInstalled($params['pid']), 'isDNSManagerRDNSenabled' => solusvmExtendedCloud_isDNSManagerRDNSenabled($params['pid']), 'isDNSManagerEnabled' => (bool) $product->getConfig('so_enablednsbutton'), 'domain' => $params['domain'], 'maxesDB' => $maxesDB, 'serviceid' => $params['serviceid']);
	$statsCurr = $cloud->getVserversStats($params);
	$statsMax = solusvmExtendedCloud_Cloud::getMaxResurces($params, $product);
	$isOptionCreateVM = solusvmExtendedCloud_Cloud::isOptionCreateVM($statsMax, $statsCurr);
	$stats = $statsMax + $statsCurr;
	$vserversInfo = array();

	foreach ($vservers as $vserver) {
		$call = $API->call('vserver-infoall', array('vserverid' => $vserver->vserverid));
		$vserversInfo[$vserver->id] = array('id' => $vserver->id, 'hostname' => $vserver->hostname, 'status' => $call['state'], 'vserverid' => $vserver->vserverid);
	}

	$response = '';
	$response .= isset($_GET['soerrmsg']) ? '<div style="background-color:#F2DEDE;padding:5px;margin-bottom:20px;">' . htmlentities(urldecode($_GET['soerrmsg'])) . '</div>' : '';
	$response .= isset($_GET['sosuccmsg']) ? '<div style="background-color:#DFF0D8;padding:5px;margin-bottom:20px;">' . htmlentities(urldecode($_GET['sosuccmsg'])) . '</div>' : '';

	foreach ($vars as $k => $v) {
		$smarty->assign($k, $v);
	}

	$smarty->assign('statsMax', $statsMax);
	$smarty->assign($stats);
	$smarty->assign('vservers', $vserversInfo);
	$smarty->assign('isOptionCreateVM', $isOptionCreateVM);
	return $response . $smarty->fetch(dirname(__FILE__) . DS . 'templates' . DS . 'clientarea.tpl');
}

function solusvmExtendedCloud_management($params)
{
	if (!empty($_REQUEST['json'])) {
		ob_clean();
		echo \MGModule\solusvmExtendedCloud\server::getJSONClientAreaPage($params, $_REQUEST);
		exit();
	}
	else {
		$whmcs6 = isset($GLOBALS['CONFIG']['Version']) && '6.0.0' <= $GLOBALS['CONFIG']['Version'];
		$isSixTemplate = $whmcs6 && \MGModule\solusvmExtendedCloud\server::isTemplateSix();

		if ($isSixTemplate) {
			add_hook('ClientAreaPrimarySidebar', 1, function(\WHMCS\View\Menu\Item $primarySidebar) use($params) {
				$panel = $primarySidebar->getChild('Service Details Overview');

				if (is_a($panel, 'WHMCS\\View\\Menu\\Item')) {
					$panel = $panel->getChild('Information');

					if (is_a($panel, 'WHMCS\\View\\Menu\\Item')) {
						$panel->setUri('clientarea.php?action=productdetails&id=' . $params['serviceid']);
						$panel->setAttributes(array());
					}
				}

				$panel = \MGModule\solusvmExtendedCloud\server::getSidebar('manageSevers', $params);
				$sidebar = $primarySidebar->addChild($panel['id'], array('label' => $panel['label'], 'uri' => $panel['uri'], 'icon' => $panel['icon']));
				$sidebar->setOrder(100);
				$sidebar->setBodyHtml($panel['html']);

				if (isset($_GET['vm'])) {
					$panel = \MGModule\solusvmExtendedCloud\server::getSidebar('managevm', $params);
					$sidebar = $primarySidebar->addChild($panel['id'], array('label' => $panel['label'], 'uri' => $panel['uri'], 'icon' => $panel['icon']));
					$sidebar->setOrder(101);
					$sidebar->setBodyHtml($panel['html']);
					$panel = \MGModule\solusvmExtendedCloud\server::getSidebar('additionalTools', $params);
					$sidebar = $primarySidebar->addChild($panel['id'], array('label' => $panel['label'], 'uri' => $panel['uri'], 'icon' => $panel['icon']));
					$sidebar->setOrder(102);
					$sidebar->setBodyHtml($panel['html']);
				}
			});
		}
		else {
			$panel = \MGModule\solusvmExtendedCloud\server::getSidebar('manageAccount', $params);
			$manageAccount = $panel['html'];
		}

		$out = \MGModule\solusvmExtendedCloud\server::getHTMLClientAreaPage($params, $_REQUEST);
		$out['vars']['manageAccount'] = $manageAccount;
		$out['vars']['isTemplateSix'] = $isSixTemplate;
		return $out;
	}
}

function solusvmExtendedCloud_AdminLink($params)
{
	$scr = "\n\t\t<script type=\"text/javascript\">\n\t\t\$(document).ready(function(){\n\t\t\t\$(\".solus_test_connection\").click(function(){\n\t\t\t\tvar \$a = \$(this);\n\t\t\t\tvar \$div = \$(this).closest(\"div\");\n\t\t\t\t\$.post(\"../clientarea.php?sylusvmcloud_ajax=1\", {\"sylusvm_act\":\"sylusvm_test\", \"serverip\":\$a.data(\"serverip\"), \"serverhostname\":\$a.data(\"serverhostname\"), \"serverusername\":\$a.data(\"serverusername\"), \"serverpassword\":\$a.data(\"serverpassword\"), \"serversecure\":\$a.data(\"serversecure\")}, function(res){\n\t\t\t\t\t\$div.css(\"color\", res.success == \"1\" ? \"green\" : \"red\").html(res.result);\n\t\t\t\t}, \"json\");\n\t\t\t\t\$div.html(\"<img src=\\\"../modules/servers/solusvmExtendedCloud/files/images/loader.gif\\\" />\");\n\t\t\t\treturn false;\n\t\t\t});\n\t\t});\n\t\t</script>\n\t\t";
	return $scr . '<div style="width:200px;"><a href="" class="solus_test_connection" data-serverip="' . $params['serverip'] . '" data-serverhostname="' . $params['serverhostname'] . '" data-serverusername="' . $params['serverusername'] . '" data-serverpassword="' . $params['serverpassword'] . '" data-serversecure="' . $params['serversecure'] . '">Test Connection</a></div>';
}

function solusvmExtendedCloud_ClientAreaCustomButtonArray($params)
{
	return array('Management' => 'management');
}

function solusvmExtendedCloud_UsageUpdate($params)
{
	try {
		solusvmExtended_debug();
		$API = new SolusVMConnectionCloud(solusvmExtendedCloud_getHostname($params), $params['serverusername'], $params['serverpassword']);
		$serverid = $params['serverid'];
		$hosting = \MGModule\solusvmExtendedCloud\mgLibs\MySQL\PdoWrapper::query("SELECT h.*, p.name\n                            FROM `tblhosting` h\n                            LEFT JOIN `tblproducts` p ON (h.packageid=p.id)\n                            WHERE h.server=?  \n                            AND h.domainstatus =?\n                            ", array($serverid, 'Active'));
		$hosting = \MGModule\solusvmExtendedCloud\mgLibs\MySQL\PdoWrapper::fetchArray($hosting);
		$today = date('d');

		foreach ($hosting as $h) {
			try {
				$cHosting = new solusvmExtended_HostingCloud($h['id']);
				$product = $cHosting->getProduct();
				$usageUpdate = $product->getConfig('usageUpdate');
				if (!$usageUpdate || $usageUpdate == 'daily') {
				}
				else {
					continue;
				}

				$API->setDebugMode($product->getConfig('so_debug'));
				$cloud = new solusvmExtendedCloud_Cloud($h['id']);
				$net = 0;
				$diskusage = 0;

				foreach ($cloud->getVservers() as $vserver) {
					$call = $API->call('vserver-infoall', array('vserverid' => $vserver->vserverid));
					if (!isset($call['status']) || !isset($call['bandwidth']) || $call['status'] != 'success') {
						continue;
					}

					$temp = explode(',', $call['bandwidth']);
					$temphdd = explode(',', $call['hdd']);
					$bandwidth = new stdClass();
					$bandwidth->used = $temp[1];
					$bandwidth->max = $temp[0];
					$bandwidth->free = $temp[2];
					$hdd = new stdClass();
					$hdd->used = $temphdd[1];
					$hdd->max = $temphdd[0];
					$hdd->free = $temphdd[2];
					$net += $bandwidth->used;
					$diskusage += $hdd->used;
				}

				if ($net || $diskusage) {
					$cHosting->bwusage = (int) MG_byteFormat2($net, 'MB');
					$cHosting->diskusage = (int) MG_byteFormat2($diskusage, 'MB');
					$cHosting->usageUpdate();
				}

				if ($product->getConfig('overagesUsege') == 'suspend' && $cHosting->isOverageUsage()) {
					$values = array('accountid' => $h['id'], 'suspendreason' => 'Overage Usage');
					$adminuser = getFullAdmin();
					$adminuser = $adminuser['username'];
					$results = localAPI('modulesuspend', $values, $adminuser);

					if ($results['result'] == 'error') {
						throw new Exception($results['message']);
					}
				}

				unset($cHosting);
				unset($product);
			}
			catch (Exception $ex) {
				logActivity('SolusvmExtendedCloud Cron Job Error: ' . $ex->getMessage());
			}
		}
	}
	catch (Exception $ex) {
		logActivity('SolusvmExtendedCloud Cron Job Error: ' . $ex->getMessage());
	}
}

function solusvmExtendedCloud_TestConnection($params)
{
	try {
		$api = new \MGModule\SolusvmExtended\service\Api(solusvmExtendedCloud_getHostname($params), $params['serverusername'], $params['serverpassword'], true);
		return array('success' => true);
	}
	catch (Exception $e) {
		return array('error' => $e->getMessage());
	}
}

function solusvmExtendedCloud_ChangePackage($params)
{
	$license_check = solusvm_extended_cloud_license_4487();

	if ($license_check['status'] != 'Active') {
		$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
		return $error_message;
	}

	return \MGModule\solusvmExtendedCloud\server::accountAction('changePackage', $params);
}

if (!defined('DS')) {
	define('DS', DIRECTORY_SEPARATOR);
}

if (isset($_REQUEST['_debug']) && $_REQUEST['_debug'] == 'turnon') {
	$_SESSION['mg_solusvm_debug'] = 1;
}
else {
	if (isset($_REQUEST['_debug']) && $_REQUEST['_debug'] == 'turnoff') {
		$_SESSION['mg_solusvm_debug'] = NULL;
	}
}

if (!class_exists('MGProvision\\solusvmExtendedCloud\\loader')) {
	require_once dirname(__FILE__) . DS . 'loader.php';
	new \MGModule\solusvmExtendedCloud\loader();
}

include_once dirname(__FILE__) . DS . 'files' . DS . 'class.SolusVMConnectionCloud.php';
include_once dirname(__FILE__) . DS . 'files' . DS . 'class.SolusVMCloud.php';
include_once dirname(__FILE__) . DS . 'class.Cloud.php';
include_once dirname(__FILE__) . DS . 'class.Vserver.php';
include_once dirname(__FILE__) . DS . 'files' . DS . 'class.WHMCSProductCloud.php';
include_once dirname(__FILE__) . DS . 'files' . DS . 'class.ProductCloud.php';
include_once dirname(__FILE__) . DS . 'files' . DS . 'class.HostingCloud.php';
include_once dirname(__FILE__) . DS . 'files' . DS . 'utilityCloud.php';
include_once dirname(__FILE__) . DS . 'solusvmExtendedCloud_Loader.php';

?>
