<?php
//dezend by http://www.yunlu99.com/
class solusvm_extended_vps_license_3960PDOWrapper
{
	static private $pdoConnection;

	static private function getDbConnection()
	{
		if (class_exists('Illuminate\\Database\\Capsule\\Manager')) {
			return \Illuminate\Database\Capsule\Manager::connection()->getPdo();
		}

		if (self::$pdoConnection === NULL) {
			self::$pdoConnection = self::setNewConnection();
		}

		return self::$pdoConnection;
	}

	static private function setNewConnection()
	{
		try {
			$includePath = ROOTDIR . DIRECTORY_SEPARATOR . 'configuration.php';

			if (file_exists($includePath)) {
				require $includePath;
			}
			else {
				throw new Exception('No configuration file found');
			}

			$connection = new PDO(sprintf('mysql:host=%s;dbname=%s;port=%s;charset=utf8', $db_host, $db_name, $db_port ? $db_port : 3360), $db_username, $db_password);
			$connection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			return $connection;
		}
		catch (PDOException $exc) {
		}
	}

	static public function query($query, $params = array())
	{
		$statement = self::getDbConnection()->prepare($query);
		$statement->execute($params);
		return $statement;
	}

	static public function real_escape_string($string)
	{
		return substr(self::getDbConnection()->quote($string), 1, -1);
	}

	static public function fetch_assoc($query)
	{
		return $query->fetch(PDO::FETCH_ASSOC);
	}

	static public function fetch_array($query)
	{
		return $query->fetch(PDO::FETCH_BOTH);
	}

	static public function fetch_object($query)
	{
		return $query->fetch(PDO::FETCH_OBJ);
	}

	static public function num_rows($query)
	{
		$query->fetch(PDO::FETCH_BOTH);
		return $query->rowCount();
	}

	static public function insert_id()
	{
		return self::getDbConnection()->lastInsertId();
	}

	static public function errorInfo()
	{
		$tmpErr = self::getDbConnection()->errorInfo();
		if ($tmpErr[0] && $tmpErr[0] !== '00000') {
			return $tmpErr;
		}

		return false;
	}

	static public function mysql_get_array($query, $params = array())
	{
		$qRes = self::query($query, $params);
		$arr = array();

		while ($row = self::fetch_assoc($qRes)) {
			$arr[] = $row;
		}

		return $arr;
	}

	static public function mysql_get_row($query, $params = array())
	{
		$qRes = self::query($query, $params);
		return self::fetch_assoc($qRes);
	}
}

function solusvm_extended_vps_license_3960()
{
	return array('status' => 'Active', 'description' => '模块破解By TrollCraft & Akkariin Meiko.');	
}

	

function solusvmExtendedVPS_load()
{
	static $loaded;

	if (empty($loaded)) {
		require_once 'loader.php';
		new \MGModule\solusvmExtendedVPS\loader();
		include_once dirname(__FILE__) . DS . 'files' . DS . 'class.SolusVMConnection.php';
		include_once dirname(__FILE__) . DS . 'files' . DS . 'class.SolusVM.php';
		include_once dirname(__FILE__) . DS . 'files' . DS . 'class.WHMCSProduct.php';
		include_once dirname(__FILE__) . DS . 'files' . DS . 'class.Product.php';
		include_once dirname(__FILE__) . DS . 'files' . DS . 'class.Hosting.php';
		include_once dirname(__FILE__) . DS . 'files' . DS . 'class.Client.php';
		include_once dirname(__FILE__) . DS . 'files' . DS . 'utility.php';

		if (file_exists(dirname(__FILE__) . DS . '..' . DS . 'solusvmExtendedVPS' . DS . 'custom.php')) {
			include_once dirname(__FILE__) . DS . '..' . DS . 'solusvmExtendedVPS' . DS . 'custom.php';
		}

		include_once dirname(__FILE__) . DIRECTORY_SEPARATOR . 'solusvmExtendedVPS_Loader.php';
		$loaded = true;
	}
}

function solusvmExtendedVPS_ConfigOptions($prameters = array())
{
	solusvmextendedvps_load();
	solusvmExtended_debug();
	$ex = explode(DS, $_SERVER['SCRIPT_FILENAME']);
	if ($_REQUEST['action'] != 'save' && end($ex) == 'configproducts.php') {
		$data = array();
		$data['mode'] = 'advanced';
		$data['content'] = '';

		try {
			$license_check = solusvm_extended_vps_license_3960();

			if ($license_check['status'] != 'Active') {
				$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
				throw new Exception($error_message);
			}

			$product = new solusvmExtended_Product($_REQUEST['id']);
			$params = $product->getParams();
			$configOption1 = trim($params['configoption1']);
			if (!$product->getConfig('vps_virtualization_type') && empty($configOption1)) {
				foreach ($product->firstConfig as $k => $v) {
					$product->saveConfig($k, $v);
				}
			}

			if (!$product->getConfig('vps_virtualization_type') && !empty($configOption1)) {
				$product->moveOldCOnfig($params);
			}

			if (empty($params)) {
				throw new Exception('Please set up solusvmExtendedVPS server first');
			}

			$type = $product->getConfig('vps_virtualization_type');
			$product->setupDefaultCustomFields();

			if (empty($type)) {
				$type = 'openvz';
			}

			$API = new SolusVMConnection(solusvmExtendedVPS_getHostname($params), $params['serverusername'], $params['serverpassword']);
			$API->timeout = 120;
			$API->setDebugMode($product->getConfig('so_debug'));
			$res_nodes = $API->call('listnodes', array('type' => $type));
			if ($res_nodes && isset($res_nodes['status']) && $res_nodes['status'] == 'success') {
				$nodes = explode(',', $res_nodes['nodes']);
			}

			$product->defaultConfig['vps_default_node']['options'] = $nodes;
			$res_plans = $API->call('listplans', array('type' => $type));
			if ($res_plans && isset($res_plans['status']) && $res_plans['status'] == 'success') {
				$plans = explode(',', $res_plans['plans']);
			}

			$product->defaultConfig['vps_plan']['options'] = $plans;
			$res_node_groups = $API->call('listnodegroups', array());
			if ($res_node_groups && isset($res_node_groups['status']) && $res_node_groups['status'] == 'success') {
				$node_groups = explode(',', $res_node_groups['nodegroups']);
			}

			$product->defaultConfig['vps_default_node_group']['options'] = $node_groups;
			$template_list = $API->getTemplates($type, true);

			if ($template_list) {
				$product->defaultConfig['vps_default_operating_system']['options'] = $template_list;
				$product->defaultConfig['templates']['options'] = $template_list;
			}

			$iso_list = $API->getIsos($type, true);

			if ($iso_list) {
				$product->defaultConfig['iso_images']['options'] = $iso_list;
				$product->defaultConfig['default_iso']['options'] = array_merge(array('None'), $iso_list);
			}
			else {
				unset($product->defaultConfig['default_iso']);
			}

			if (!$res_nodes && !$res_plans && !$res_node_groups && !$res_templates) {
				throw new Exception('Could not connect to SolusVM server. Please, check your configuration');
			}

			$product->defaultConfig['nspeed']['options'] = $product->getNetworkSpeedOptions();
			$js = "\n\t\t\t\t<script type=\"text/javascript\">\n\t\t\t\t\$(document).ready(function(){\n\t\t\t\t\t\$(\"#solus_configurable_options\").click(function(){\n\t\t\t\t\t\t\$.post(\"../clientarea.php?sylusvm_ajax=1\", {\"sylusvm_act\":\"sylusvm_setup_configurable_options\", \"productid\":" . (int) $_REQUEST['id'] . "}, function(res){\n\t\t\t\t\t\t\talert(res.result);\n\t\t\t\t\t\t\tif(\$(\"#tabLink5\").size())\n                                                              window.location.href = \"configproducts.php?action=edit&id=" . $_REQUEST['id'] . "&tab=5\";\n                                                          else\n                                                              window.location.href = \"configproducts.php?action=edit&id=" . $_REQUEST['id'] . "&tab=4\";\n\t\t\t\t\t\t}, \"json\");\n\t\t\t\t\t\treturn false;\n\t\t\t\t\t});\n                                        \n\t\t\t\t\t\$(\"#solus_copy_configurable_options\").click(function(){\n\t\t\t\t\t\t\$.post(\"../clientarea.php?sylusvm_ajax=1\", {\"sylusvm_act\":\"sylusvm_copy_configurable_options\", \"productid\":" . (int) $_REQUEST['id'] . "}, function(res){\n\t\t\t\t\t\t\talert(res.result);\n                                                        if(\$(\"#tabLink5\").size())\n                                                              window.location.href = \"configproducts.php?action=edit&id=" . $_REQUEST['id'] . "&tab=5\";\n                                                          else\n                                                              window.location.href = \"configproducts.php?action=edit&id=" . $_REQUEST['id'] . "&tab=4\";\n\t\t\t\t\t\t}, \"json\");\n\t\t\t\t\t\treturn false;\n\t\t\t\t\t});\n\t\t\t\t\t\n\t\t\t\t\t\$(\"#solus_custom_fields\").click(function(){\n\t\t\t\t\t\t\$.post(\"../clientarea.php?sylusvm_ajax=1\", {\"sylusvm_act\":\"sylusvm_setup_custom_fields\", \"productid\":" . (int) $_REQUEST['id'] . "}, function(res){\n\t\t\t\t\t\t\talert(res.result);\n\t\t\t\t\t\t\twindow.location.href = \"configproducts.php?action=edit&id=" . (int) $_REQUEST['id'] . "&tab=3\";\n\t\t\t\t\t\t}, \"json\");\n\t\t\t\t\t\treturn false;\n\t\t\t\t\t});\n\t\t\t\t\t\n\t\t\t\t\t\$(\".so_popup\").click(function(){\n\t\t\t\t\t\twindow.open(\"../modules/servers/solusvmExtendedVPS/templates/\" + \$(this).attr(\"rel\"), \"\",\"width=750,height=350,scrollbars=yes\");\n\t\t\t\t\t\treturn false;\n\t\t\t\t\t});\n                                   //Copy Setup From\n                                   \$(\"select[name='customconfigoption[productTarget]']\").change(function() {\n                                      if(confirm(\"Are you sure to copy setup from selected product?\")){\n                                          \$(\"form[name=packagefrm]\").submit();\n                                      }\n                                  });\n                                   // templates & iso\n                                   \$(\"#so_synchronize_templates\").click(function(){\n                                          \$(\"#loading_templates\").show();\n\t\t\t\t\t       var type = \$(\"select[name='customconfigoption[virtualization_type]']\").val();\n\t\t\t\t\t\t\$.post(\"../clientarea.php?sylusvm_ajax=1\", {\"sylusvm_act\":\"synchronize_templates\", \"productid\":" . (int) $_REQUEST['id'] . "}, function(res){\n                                                 \$(\"#loading_templates\").hide();\n\t\t\t\t\t\t\talert(res.result);\n\t\t\t\t\t\t}, \"json\");\n\t\t\t\t\t\treturn false;\n\t\t\t\t\t});\n                                   //reload\n                                   \$(\"select[name='customconfigoption[vps_virtualization_type]']\").change(function() {\n                                            if(confirm(\"Choosing this option causes reload the configuration.\")){\n                                                \$(\"form[name=packagefrm]\").submit();\n                                            }\n                                   });\n\t\t\t\t});\n\t\t\t\t</script>\n\t\t\t";
			$productsForCopy = $product->getProductsForCopy();
			$product->defaultConfig['productTarget']['options'] += $productsForCopy;

			if (empty($productsForCopy)) {
				unset($product->defaultConfig['productTarget']);
			}

			if (!$product->hasConfigurableOptions()) {
				unset($product->defaultConfig['update_templates']);
			}

			$product->defaultConfig['nodesFriendlyNames'] = 'Nodes Friendly Name';

			foreach ($nodes as $node) {
				$product->defaultConfig['nfn_' . $node] = array('title' => $node, 'type' => 'text', 'default' => $node, 'description' => '');
			}

			$data['content'] .= $product->renderConfigOptions($js);
		}
		catch (Exception $ex) {
			$data['content'] .= '<div class="errorbox">' . $ex->getMessage() . '</span></div>';
		}

		if (isset($_REQUEST['mode']) && $_REQUEST['mode'] == 'simple') {
			if (0 < ob_get_level()) {
				ob_start();
				ob_clean();
			}

			header('Content-Type: application/json');
			echo json_encode($data);
			exit();
		}
		else {
			echo $data['content'];
		}

		return array();
	}
}

function solusvmExtendedVPS_CreateAccount($params)
{
	solusvmextendedvps_load();
	$license_check = solusvm_extended_vps_license_3960();

	if ($license_check['status'] != 'Active') {
		$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
		echo '<strong>License Error: ' . $error_message . '</strong>';
		return $error_message;
	}

	try {
		$loader = new \MGModule\solusvmExtendedVPS\loader();
		return \MGModule\solusvmExtendedVPS\server::accountAction('createAccount', $params);
	}
	catch (Exception $ex) {
		\MGModule\solusvmExtendedVPS\server::dump($ex);
		return $ex->getMessage();
	}
}

function solusvmExtendedVPS_TerminateAccount($params)
{
	solusvmextendedvps_load();
	$license_check = solusvm_extended_vps_license_3960();

	if ($license_check['status'] != 'Active') {
		$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
		echo '<strong>License Error: ' . $error_message . '</strong>';
		return $error_message;
	}

	try {
		$loader = new \MGModule\solusvmExtendedVPS\loader();
		return \MGModule\solusvmExtendedVPS\server::accountAction('terminateAccount', $params);
	}
	catch (Exception $ex) {
		return $ex->getMessage();
	}
}

function solusvmExtendedVPS_SuspendAccount($params)
{
	solusvmextendedvps_load();
	$license_check = solusvm_extended_vps_license_3960();

	if ($license_check['status'] != 'Active') {
		$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
		echo '<strong>License Error: ' . $error_message . '</strong>';
		return $error_message;
	}

	try {
		$loader = new \MGModule\solusvmExtendedVPS\loader();
		return \MGModule\solusvmExtendedVPS\server::accountAction('suspendAccount', $params);
	}
	catch (Exception $ex) {
		return $ex->getMessage();
	}
}

function solusvmExtendedVPS_UnsuspendAccount($params)
{
	solusvmextendedvps_load();
	$license_check = solusvm_extended_vps_license_3960();

	if ($license_check['status'] != 'Active') {
		$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
		echo '<strong>License Error: ' . $error_message . '</strong>';
		return $error_message;
	}

	try {
		$loader = new \MGModule\solusvmExtendedVPS\loader();
		return \MGModule\solusvmExtendedVPS\server::accountAction('unsuspendAccount', $params);
	}
	catch (Exception $ex) {
		return $ex->getMessage();
	}
}

function solusvmExtendedVPS_ChangePackage($params)
{
	solusvmextendedvps_load();

	try {
		solusvmExtendedVPS_runHook('solusvmExtendedVPS_changepackage_pre', $params);
		$loader = new \MGModule\solusvmExtendedVPS\loader();
		return \MGModule\solusvmExtendedVPS\server::accountAction('changePackage', $params);
	}
	catch (Exception $ex) {
		$params['exception'] = $ex;
		solusvmExtendedVPS_runHook('solusvmExtendedVPS_changepackage_post_error', $params);
		return $ex->getMessage();
	}
}

function solusvmExtendedVPS_Reboot($params)
{
	$license_check = solusvm_extended_vps_license_3960();

	if ($license_check['status'] != 'Active') {
		$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
		echo '<strong>License Error: ' . $error_message . '</strong>';
		return $error_message;
	}

	solusvmextendedvps_load();

	try {
		$loader = new \MGModule\solusvmExtendedVPS\loader();
		return \MGModule\solusvmExtendedVPS\server::accountAction('reboot', $params);
	}
	catch (Exception $ex) {
		return $ex->getMessage();
	}
}

function solusvmExtendedVPS_shutdown($params)
{
	$license_check = solusvm_extended_vps_license_3960();

	if ($license_check['status'] != 'Active') {
		$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
		echo '<strong>License Error: ' . $error_message . '</strong>';
		return $error_message;
	}

	try {
		$loader = new \MGModule\solusvmExtendedVPS\loader();
		return \MGModule\solusvmExtendedVPS\server::accountAction('shutdown', $params);
	}
	catch (Exception $ex) {
		return $ex->getMessage();
	}
}

function solusvmExtendedVPS_boot($params)
{
	$license_check = solusvm_extended_vps_license_3960();

	if ($license_check['status'] != 'Active') {
		$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
		echo '<strong>License Error: ' . $error_message . '</strong>';
		return $error_message;
	}

	try {
		$loader = new \MGModule\solusvmExtendedVPS\loader();
		return \MGModule\solusvmExtendedVPS\server::accountAction('boot', $params);
	}
	catch (Exception $ex) {
		return $ex->getMessage();
	}
}

function solusvmExtendedVPS_enabletuntap($params)
{
	try {
		solusvmextendedvps_load();
		return \MGModule\solusvmExtendedVPS\server::accountAction('enableTunTap', $params);
	}
	catch (Exception $ex) {
		return $ex->getMessage();
	}
}

function solusvmExtendedVPS_disabletuntap($params)
{
	try {
		solusvmextendedvps_load();
		return \MGModule\solusvmExtendedVPS\server::accountAction('disableTunTap', $params);
	}
	catch (Exception $ex) {
		return $ex->getMessage();
	}
}

function solusvmExtendedVPS_enablePxe($params)
{
	try {
		solusvmextendedvps_load();
		return \MGModule\solusvmExtendedVPS\server::accountAction('enablePxe', $params);
	}
	catch (Exception $ex) {
		return $ex->getMessage();
	}
}

function solusvmExtendedVPS_disablePxe($params)
{
	try {
		solusvmextendedvps_load();
		return \MGModule\solusvmExtendedVPS\server::accountAction('disablePxe', $params);
	}
	catch (Exception $ex) {
		return $ex->getMessage();
	}
}

function solusvmExtendedVPS_AdminServicesTabFields($params)
{
	$license_check = solusvm_extended_vps_license_3960();

	if ($license_check['status'] != 'Active') {
		$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
		return array('License' => '<span class="label terminated">' . $error_message . '</span>');
	}

	solusvmextendedvps_load();
	$product = new solusvmExtended_Product(NULL, $params['serviceid']);
	require_once dirname(__FILE__) . DS . 'files' . DS . 'scripts' . DS . 'scripts.php';
	$serviceFields = array();

	if (in_array($product->getConfig('vps_virtualization_type'), array('openvz', 'xen'))) {
		$serialConsoleUrl = '../dologin.php?username=' . urlencode($params['clientsdetails']['email']) . '&goto=' . urlencode('clientarea.php?action=productdetails&id=' . $params['serviceid'] . '&mg-action=serialConsole');
		$serviceFields['Control'] = '<input class="btn btn-default" type="button" onclick="window.open(\'' . $serialConsoleUrl . '\', \'\', \'width=820,height=555\');" value="HTML 5 Serial Console">';
	}

	$serviceFields['ISO'] = '<div id="solusvm_iso_alert"></div>		<a href="" id="solusvm_show_iso">Mount ISO</a> <a href="" id="solusvm_unmount_iso">Unmount ISO</a>' . $style . $script;
	$serviceFields['Rebuild'] = '<div id="solusvm_rebuild_alert"></div>	<a href="" id="solusvm_show_templates">Show Templates</a>  <input type="button" class="btn" id="btn_solusvm_rebuild" value="Rebuild">';
	$serviceFields['Client Password'] = '<div id="solusvm_client_password_alert"></div>	<input type="text" name="solusvm_client_password" id="solusvm_client_password" /> <input type="button" class="btn" id="btn_solusvm_client_password" value="Change Password" onclick="timedRefresh();">';
	$serviceFields['VNC Password'] = '<div id="solusvm_vnc_password_alert"></div>		<input type="text" name="solusvm_vnc_password" id="solusvm_vnc_password" /> <input type="button" class="btn" id="btn_solusvm_vnc_password" value="Change Password">';
	$serviceFields['PAE'] = '<div id="solusvm_pae_alert"></div>				<input type="button" class="btn" id="btn_solusvm_pae_enable" value="Enable"> <input type="button" class="btn" id="btn_solusvm_pae_disable" value="Disable">';
	$serviceFields['Boot Order'] = '<div id="solusvm_bootorder_alert"></div>		<select name="solusvm_bootorder" id="solusvm_bootorder"><option value=""></option><option value="cd">(1) Hard Disk (2) CDROM</option><option value="dc">(1) CDROM (2) Hard Disk</option><option value="c">(1) Hard Disk</option><option value="d">(1) CDROM</option></select> <input type="button" class="btn" id="btn_solusvm_bootorder" value="Change">';
	$serviceFields['Status <a href="" class="so_refresh"><img src="../modules/servers/solusvmExtendedVPS/files/images/refresh.gif"></a>'] = '<div id="so_stats">' . (isset($stats) ? $stats : '') . '</div>';
	return $serviceFields;
}

function solusvmExtendedVPS_management($params)
{
	solusvmextendedvps_load();

	if (!empty($_REQUEST['json'])) {
		if (0 < ob_get_level()) {
			ob_start();
			ob_clean();
		}

		echo \MGModule\solusvmExtendedVPS\server::getJSONClientAreaPage($params, $_REQUEST);
		exit();
	}
	else {
		$whmcs6 = isset($GLOBALS['CONFIG']['Version']) && '6.0.0' <= $GLOBALS['CONFIG']['Version'];
		$isSixTemplate = \MGModule\solusvmExtendedVPS\server::isTemplateSix();

		if ($isSixTemplate) {
			add_hook('ClientAreaPrimarySidebar', 1, function(\WHMCS\View\Menu\Item $primarySidebar) use($params) {
				$panel = $primarySidebar->getChild('Service Details Actions');

				if (is_a($panel, 'WHMCS\\View\\Menu\\Item')) {
					$panel = $panel->getChild('Change Password');

					if (is_a($panel, 'WHMCS\\View\\Menu\\Item')) {
						$panel->setUri('clientarea.php?action=productdetails&id=' . $params['serviceid'] . '#tabChangepw');
						$panel->setAttributes(array());
					}
				}

				$panel = $primarySidebar->getChild('Service Details Overview');

				if (is_a($panel, 'WHMCS\\View\\Menu\\Item')) {
					$panel = $panel->getChild('Information');

					if (is_a($panel, 'WHMCS\\View\\Menu\\Item')) {
						$panel->setUri('clientarea.php?action=productdetails&id=' . $params['serviceid']);
						$panel->setAttributes(array());
					}
				}

				$panel = \MGModule\solusvmExtendedVPS\server::getSidebar('managevm', $params);
				$sidebar = $primarySidebar->addChild($panel['id'], array('label' => $panel['label'], 'uri' => $panel['uri'], 'icon' => $panel['icon'], 'order' => 20));
				$sidebar->setBodyHtml($panel['html']);
				$panel = \MGModule\solusvmExtendedVPS\server::getSidebar('additionalTools', $params);
				$sidebar = $primarySidebar->addChild($panel['id'], array('label' => $panel['label'], 'uri' => $panel['uri'], 'icon' => $panel['icon'], 'order' => 30));
				$sidebar->setBodyHtml($panel['html']);
			});
		}
		else {
			$panel = \MGModule\solusvmExtendedVPS\server::getSidebar('manageAccount', $params);
			$manageAccount = $panel['html'];
		}

		$out = \MGModule\solusvmExtendedVPS\server::getHTMLClientAreaPage($params, $_REQUEST);
		$out['vars']['manageAccount'] = $manageAccount;
		$out['vars']['isTemplateSix'] = $isSixTemplate;
		return $out;
	}
}

function solusvmExtendedVPS_AdminLink($params)
{
	$scr = "\n\t\t<script type=\"text/javascript\">\n\t\t\$(document).ready(function(){\n\t\t\t\$(\".solus_test_connection\").click(function(){\n\t\t\t\tvar \$a = \$(this);\n\t\t\t\tvar \$div = \$(this).closest(\"div\");\n\t\t\t\t\$.post(\"../clientarea.php?sylusvm_ajax=1\", {\"sylusvm_act\":\"sylusvm_test\", \"serverip\":\$a.data(\"serverip\"), \"serverhostname\":\$a.data(\"serverhostname\"), \"serverusername\":\$a.data(\"serverusername\"), \"serverpassword\":\$a.data(\"serverpassword\"), \"serversecure\":\$a.data(\"serversecure\")}, function(res){\n\t\t\t\t\t\$div.css(\"color\", res.success == \"1\" ? \"green\" : \"red\").html(res.result);\n\t\t\t\t}, \"json\");\n\t\t\t\t\$div.html(\"<img src=\\\"../modules/servers/solusvmExtendedVPS/files/images/loader.gif\\\" />\");\n\t\t\t\treturn false;\n\t\t\t});\n\t\t});\n\t\t</script>\n\t\t";
	return $scr . '<div style="width:200px;"><a href="" class="solus_test_connection" data-serverip="' . $params['serverip'] . '" data-serverhostname="' . $params['serverhostname'] . '" data-serverusername="' . $params['serverusername'] . '" data-serverpassword="' . $params['serverpassword'] . '" data-serversecure="' . $params['serversecure'] . '">Test Connection</a></div>';
}

function solusvmExtendedVPS_ClientAreaCustomButtonArray($params)
{
	$buttons = array();
	$buttons['Management'] = 'management';
	return $buttons;
}

function solusvmExtendedVPS_AdminCustomButtonArray()
{
	solusvmextendedvps_load();

	if (isset($_GET['id'])) {
		$product = new solusvmExtended_Product(NULL, $_GET['id']);
		$params = $product->getParams('solusvmExtendedVPS');

		if ($params) {
			$type = $product->getConfig('vps_virtualization_type');
		}
	}

	$arr = array('Reboot' => 'reboot', 'Shutdown' => 'shutdown', 'Boot' => 'boot');
	if (!isset($type) || $type != 'kvm') {
		$arr['Enable TUN/TAP'] = 'enabletuntap';
		$arr['Disable TUN/TAP'] = 'disabletuntap';
	}

	$arr['Enable PXE'] = 'enablePxe';
	$arr['Disable PXE'] = 'disablePxe';
	return $arr;
}

function solusvmExtendedVPS_sendEmailAfterCreate($type, $serviceid, $vars)
{
	solusvmextendedvps_load();

	switch ($type) {
	case 'openvz':
		$messagename = 'OpenVZ Virtual Server';
		break;

	case 'xen':
		$messagename = 'Xen PV Virtual Server';
		break;

	case 'xen hvm':
		$messagename = 'Xen HVM';
		break;

	case 'kvm':
		$messagename = 'KVM Virtual Server';
		break;

	default:
		return false;
	}

	$masterAdmin = getMasterAdminId();
	$results = localAPI('sendemail', array('messagename' => $messagename, 'id' => $serviceid, 'customvars' => base64_encode(serialize($vars))), $masterAdmin);
}

function solusvmExtendedVPS_runHook($name, $params)
{
	if (function_exists($name)) {
		return call_user_func($name, $params);
	}
}

function solusvmExtendedVPS_TestConnection($params)
{
	try {
		solusvmextendedvps_load();
		$Api = new \MGModule\SolusvmExtended\service\Api(solusvmExtendedVPS_getHostname($params), $params['serverusername'], $params['serverpassword'], true);
		return array('success' => true);
	}
	catch (Exception $e) {
		return array('error' => $e->getMessage());
	}
}

function solusvmExtendedVPS_ClientArea($params)
{
	if ($_GET['modop'] == 'custom' && $_GET['a'] == 'management') {
		return NULL;
	}

	solusvmextendedvps_load();

	if (!empty($_REQUEST['json'])) {
		if (0 < ob_get_level()) {
			ob_start();
			ob_clean();
		}

		echo \MGModule\solusvmExtendedVPS\server::getJSONClientAreaPage($params, $_REQUEST);
		exit();
	}
	else {
		$custom = solusvmextendedvps_runhook('solusvmExtendedVPS_customclientarea', $params);

		if ($custom) {
			return $custom;
		}

		return \MGModule\solusvmExtendedVPS\server::getHTMLClientAreaPage($params, $_REQUEST);
	}
}

function solusvmExtendedVPS_UsageUpdate($params)
{
	try {
		solusvmextendedvps_load();
		solusvmExtended_debug();
		$api = new \MGModule\SolusvmExtended\service\Api(solusvmExtendedVPS_getHostname($params), $params['serverusername'], $params['serverpassword'], false);
		$serverid = $params['serverid'];
		$hostings = \MGModule\solusvmExtendedVPS\mgLibs\MySQL\PdoWrapper::query("SELECT h.*, p.name\n                            FROM `tblhosting` h\n                            LEFT JOIN `tblproducts` p ON (h.packageid=p.id)\n                            WHERE h.server=?  \n                            AND h.domainstatus =?\n                            ", array($serverid, 'Active'));
		$hostings = \MGModule\solusvmExtendedVPS\mgLibs\MySQL\PdoWrapper::fetchArray($hostings);
		$today = date('d');

		foreach ($hostings as $h) {
			try {
				$cHosting = new solusvmExtended_Hosting($h['id']);
				$product = $cHosting->getProduct();
				$api->setDebugMode($product->getConfig('so_debug'));
				$custonFields = $cHosting->getCustomFields(true);
				$vm = $api->getVM($custonFields['vserverid']);
				$net = 0;
				$diskusage = 0;
				$call = $vm->infoall();
				$info = $vm->info();
				if (!isset($call['status']) || !isset($call['bandwidth']) || $call['status'] != 'success') {
					continue;
				}

				$temp = explode(',', $call['bandwidth']);
				$temphdd = explode(',', $call['hdd']);
				$bandwidth = new stdClass();
				$bandwidth->used = $temp[1];
				$bandwidth->max = $temp[0];
				$bandwidth->free = $temp[2];
				$hdd = new stdClass();
				$hdd->used = $temphdd[1];
				$hdd->max = $temphdd[0] ? $temphdd[0] : $info['hdd'];
				$hdd->free = $temphdd[2];
				$net += $bandwidth->used;
				$diskusage += $hdd->used;
				if ($net || $diskusage) {
					$cHosting->bwusage = (int) MG_byteFormat2($net, 'MB');
					$cHosting->diskusage = (int) MG_byteFormat2($diskusage, 'MB');
					$cHosting->usageUpdate($bandwidth->max, $hdd->max);
				}

				if ($product->getConfig('overagesUsege') === 'suspend' && $cHosting->isOverageUsage()) {
					$values = array('accountid' => $h['id'], 'suspendreason' => 'Overage Usage');
					$adminuser = getFullAdmin();
					$adminuser = $adminuser['username'];
					$results = localAPI('modulesuspend', $values, $adminuser);

					if ($results['result'] == 'error') {
						throw new Exception($results['message']);
					}
				}

				unset($cHosting);
				unset($product);
			}
			catch (Exception $ex) {
				logActivity('SolusvmExtendedVPS Cron Job Error: ' . $ex->getMessage());
			}
		}
	}
	catch (Exception $ex) {
		logActivity('SolusvmExtendedVPS Cron Job Error: ' . $ex->getMessage());
	}
}

if (!defined('DS')) {
	define('DS', DIRECTORY_SEPARATOR);
}

if (isset($_REQUEST['_debug']) && $_REQUEST['_debug'] == 'turnon') {
	$_SESSION['mg_solusvm_debug'] = 1;
}
else {
	if (isset($_REQUEST['_debug']) && $_REQUEST['_debug'] == 'turnoff') {
		$_SESSION['mg_solusvm_debug'] = NULL;
	}
}

if ($_REQUEST['id']) {
	try {
		solusvmextendedvps_load();
		$caf_change_password = (bool) \MGModule\solusvmExtendedVPS\mgLibs\MySQL\PdoWrapper::numRows(\MGModule\solusvmExtendedVPS\mgLibs\MySQL\PdoWrapper::query("SELECT p.`value`\n                                                              FROM `solusvmextended_settings` p\n                                                              LEFT JOIN tblhosting h ON ( h.packageid = p.product_id )\n                                                              WHERE h.id =?\n                                                              AND p.`setting` = ?\n                                                              AND p.`value` = ? ", array($_REQUEST['id'], 'so_rootpassword_change', '1')));
		$isKVM = (bool) \MGModule\solusvmExtendedVPS\mgLibs\MySQL\PdoWrapper::numRows(\MGModule\solusvmExtendedVPS\mgLibs\MySQL\PdoWrapper::query("SELECT p.`value`\n                                                              FROM `solusvmextended_settings` p\n                                                              LEFT JOIN tblhosting h ON ( h.packageid = p.product_id )\n                                                              WHERE h.id =?\n                                                              AND p.`setting` = ?\n                                                              AND p.`value` = ? ", array($_REQUEST['id'], 'vps_virtualization_type', 'kvm')));
	}
	catch (Exception $ex) {
	}
}

if ($caf_change_password && !$isKVM) {
	function solusvmExtendedVPS_ChangePassword($params)
	{
		solusvmextendedvps_load();
		$license_check = solusvm_extended_vps_license_3960();

		if ($license_check['status'] != 'Active') {
			$error_message = isset($license_custom_error_message) ? $license_custom_error_message : 'License ' . $license_check['status'] . ($license_check['description'] ? ': ' . $license_check['description'] : '');
			echo '<strong>License Error: ' . $error_message . '</strong>';
			return $error_message;
		}

		try {
			$loader = new \MGModule\solusvmExtendedVPS\loader();
			return \MGModule\solusvmExtendedVPS\server::accountAction('changePassword', $params);
		}
		catch (Exception $ex) {
			return $ex->getMessage();
		}
	}
}

?>
